/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

#define yylval          cf_lval
#define yychar          cf_char

/* Copy the first part of user declarations.  */
#line 1 "cf-parse.y" /* yacc.c:339  */

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  struct f_tree *lst = NULL;
  int i;

  if ((fa == ta) || ((fb == 0) && (tb == 0xFFFF)))
    return f_new_pair_item(fa, ta, fb, tb);
  
  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define EC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{ 
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;
  
    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;    
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}



/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

#ifdef OSPFv2
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}
#endif

#ifdef OSPFv3
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if ((ip->autype != OSPF_AUTH_NONE) || (get_passwords() != NULL))
    cf_error("Authentication not supported in OSPFv3");
}
#endif

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only Stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
     backbone = 1;
  }
  cf->abr = areano > 1;

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error( "Vlinks cannot be used on single area router");
}

static inline void
check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
set_instance_id(unsigned id)
{
#ifdef OSPFv3
  OSPF_PATT->instance_id = id;
#else
  cf_error("Instance ID requires OSPFv3");
#endif
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

#ifdef IPV6
#define RIP_DEFAULT_TTL_SECURITY 2
#else
#define RIP_DEFAULT_TTL_SECURITY 0
#endif

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;


#line 596 "cf-parse.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    END = 258,
    CLI_MARKER = 259,
    INVALID_TOKEN = 260,
    ELSECOL = 261,
    DDOT = 262,
    GEQ = 263,
    LEQ = 264,
    NEQ = 265,
    AND = 266,
    OR = 267,
    PO = 268,
    PC = 269,
    NUM = 270,
    ENUM = 271,
    RTRID = 272,
    IPA = 273,
    SYM = 274,
    TEXT = 275,
    PREFIX_DUMMY = 276,
    DEFINE = 277,
    ON = 278,
    OFF = 279,
    YES = 280,
    NO = 281,
    S = 282,
    MS = 283,
    US = 284,
    PORT = 285,
    LOG = 286,
    SYSLOG = 287,
    ALL = 288,
    DEBUG = 289,
    TRACE = 290,
    INFO = 291,
    REMOTE = 292,
    WARNING = 293,
    ERROR = 294,
    AUTH = 295,
    FATAL = 296,
    BUG = 297,
    STDERR = 298,
    SOFT = 299,
    TIMEFORMAT = 300,
    ISO = 301,
    OLD = 302,
    SHORT = 303,
    LONG = 304,
    BASE = 305,
    NAME = 306,
    CONFIRM = 307,
    UNDO = 308,
    CHECK = 309,
    TIMEOUT = 310,
    CONFIGURE = 311,
    DOWN = 312,
    KERNEL = 313,
    PERSIST = 314,
    SCAN = 315,
    TIME = 316,
    LEARN = 317,
    DEVICE = 318,
    ROUTES = 319,
    GRACEFUL = 320,
    RESTART = 321,
    KRT_SOURCE = 322,
    KRT_METRIC = 323,
    TABLE = 324,
    KRT_PREFSRC = 325,
    KRT_REALM = 326,
    ROUTER = 327,
    ID = 328,
    PROTOCOL = 329,
    TEMPLATE = 330,
    PREFERENCE = 331,
    DISABLED = 332,
    DIRECT = 333,
    INTERFACE = 334,
    IMPORT = 335,
    EXPORT = 336,
    FILTER = 337,
    NONE = 338,
    STATES = 339,
    FILTERS = 340,
    RECEIVE = 341,
    LIMIT = 342,
    ACTION = 343,
    WARN = 344,
    BLOCK = 345,
    DISABLE = 346,
    KEEP = 347,
    FILTERED = 348,
    PASSWORD = 349,
    FROM = 350,
    PASSIVE = 351,
    TO = 352,
    EVENTS = 353,
    PACKETS = 354,
    PROTOCOLS = 355,
    INTERFACES = 356,
    PRIMARY = 357,
    STATS = 358,
    COUNT = 359,
    FOR = 360,
    COMMANDS = 361,
    PREEXPORT = 362,
    NOEXPORT = 363,
    GENERATE = 364,
    ROA = 365,
    LISTEN = 366,
    BGP = 367,
    V6ONLY = 368,
    DUAL = 369,
    ADDRESS = 370,
    PASSWORDS = 371,
    DESCRIPTION = 372,
    SORTED = 373,
    RELOAD = 374,
    IN = 375,
    OUT = 376,
    MRTDUMP = 377,
    MESSAGES = 378,
    RESTRICT = 379,
    MEMORY = 380,
    IGP_METRIC = 381,
    CLASS = 382,
    DSCP = 383,
    WAIT = 384,
    MAX = 385,
    FLUSH = 386,
    AS = 387,
    SHOW = 388,
    STATUS = 389,
    SUMMARY = 390,
    ROUTE = 391,
    SYMBOLS = 392,
    ADD = 393,
    DELETE = 394,
    DUMP = 395,
    RESOURCES = 396,
    SOCKETS = 397,
    NEIGHBORS = 398,
    ATTRIBUTES = 399,
    EVAL = 400,
    ECHO = 401,
    ENABLE = 402,
    FUNCTION = 403,
    PRINT = 404,
    PRINTN = 405,
    UNSET = 406,
    RETURN = 407,
    ACCEPT = 408,
    REJECT = 409,
    QUITBIRD = 410,
    INT = 411,
    BOOL = 412,
    IP = 413,
    PREFIX = 414,
    PAIR = 415,
    QUAD = 416,
    EC = 417,
    SET = 418,
    STRING = 419,
    BGPMASK = 420,
    BGPPATH = 421,
    CLIST = 422,
    ECLIST = 423,
    IF = 424,
    THEN = 425,
    ELSE = 426,
    CASE = 427,
    TRUE = 428,
    FALSE = 429,
    RT = 430,
    RO = 431,
    UNKNOWN = 432,
    GENERIC = 433,
    GW = 434,
    NET = 435,
    MASK = 436,
    PROTO = 437,
    SOURCE = 438,
    SCOPE = 439,
    CAST = 440,
    DEST = 441,
    IFNAME = 442,
    IFINDEX = 443,
    LEN = 444,
    DEFINED = 445,
    CONTAINS = 446,
    RESET = 447,
    PREPEND = 448,
    FIRST = 449,
    LAST = 450,
    MATCH = 451,
    ROA_CHECK = 452,
    EMPTY = 453,
    WHERE = 454,
    BFD = 455,
    MIN = 456,
    IDLE = 457,
    RX = 458,
    TX = 459,
    INTERVAL = 460,
    MULTIPLIER = 461,
    MULTIHOP = 462,
    NEIGHBOR = 463,
    DEV = 464,
    LOCAL = 465,
    SESSIONS = 466,
    HOLD = 467,
    CONNECT = 468,
    RETRY = 469,
    KEEPALIVE = 470,
    STARTUP = 471,
    VIA = 472,
    NEXT = 473,
    HOP = 474,
    SELF = 475,
    DEFAULT = 476,
    PATH = 477,
    METRIC = 478,
    START = 479,
    DELAY = 480,
    FORGET = 481,
    AFTER = 482,
    BGP_PATH = 483,
    BGP_LOCAL_PREF = 484,
    BGP_MED = 485,
    BGP_ORIGIN = 486,
    BGP_NEXT_HOP = 487,
    BGP_ATOMIC_AGGR = 488,
    BGP_AGGREGATOR = 489,
    BGP_COMMUNITY = 490,
    BGP_EXT_COMMUNITY = 491,
    RR = 492,
    RS = 493,
    CLIENT = 494,
    CLUSTER = 495,
    AS4 = 496,
    ADVERTISE = 497,
    IPV4 = 498,
    CAPABILITIES = 499,
    PREFER = 500,
    OLDER = 501,
    MISSING = 502,
    LLADDR = 503,
    DROP = 504,
    IGNORE = 505,
    REFRESH = 506,
    INTERPRET = 507,
    COMMUNITIES = 508,
    BGP_ORIGINATOR_ID = 509,
    BGP_CLUSTER_LIST = 510,
    IGP = 511,
    GATEWAY = 512,
    RECURSIVE = 513,
    MED = 514,
    TTL = 515,
    SECURITY = 516,
    DETERMINISTIC = 517,
    SECONDARY = 518,
    ALLOW = 519,
    PATHS = 520,
    AWARE = 521,
    OSPF = 522,
    AREA = 523,
    OSPF_METRIC1 = 524,
    OSPF_METRIC2 = 525,
    OSPF_TAG = 526,
    OSPF_ROUTER_ID = 527,
    RFC1583COMPAT = 528,
    STUB = 529,
    TICK = 530,
    COST = 531,
    COST2 = 532,
    RETRANSMIT = 533,
    HELLO = 534,
    TRANSMIT = 535,
    PRIORITY = 536,
    DEAD = 537,
    TYPE = 538,
    BROADCAST = 539,
    BCAST = 540,
    NONBROADCAST = 541,
    NBMA = 542,
    POINTOPOINT = 543,
    PTP = 544,
    POINTOMULTIPOINT = 545,
    PTMP = 546,
    SIMPLE = 547,
    AUTHENTICATION = 548,
    STRICT = 549,
    CRYPTOGRAPHIC = 550,
    ELIGIBLE = 551,
    POLL = 552,
    NETWORKS = 553,
    HIDDEN = 554,
    VIRTUAL = 555,
    LINK = 556,
    ONLY = 557,
    BUFFER = 558,
    LARGE = 559,
    NORMAL = 560,
    STUBNET = 561,
    TAG = 562,
    EXTERNAL = 563,
    LSADB = 564,
    ECMP = 565,
    WEIGHT = 566,
    NSSA = 567,
    TRANSLATOR = 568,
    STABILITY = 569,
    GLOBAL = 570,
    LSID = 571,
    INSTANCE = 572,
    REAL = 573,
    NETMASK = 574,
    LENGTH = 575,
    MERGE = 576,
    TOPOLOGY = 577,
    STATE = 578,
    PIPE = 579,
    PEER = 580,
    MODE = 581,
    OPAQUE = 582,
    TRANSPARENT = 583,
    RIP = 584,
    INFINITY = 585,
    PERIOD = 586,
    GARBAGE = 587,
    MULTICAST = 588,
    QUIET = 589,
    NOLISTEN = 590,
    VERSION1 = 591,
    PLAINTEXT = 592,
    MD5 = 593,
    HONOR = 594,
    NEVER = 595,
    ALWAYS = 596,
    RIP_METRIC = 597,
    RIP_TAG = 598,
    STATIC = 599,
    PROHIBIT = 600,
    MULTIPATH = 601,
    BLACKHOLE = 602,
    UNREACHABLE = 603
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 525 "cf-parse.y" /* yacc.c:355  */

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;

#line 1012 "cf-parse.tab.c" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE cf_lval;

int cf_parse (void);

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1027 "cf-parse.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  67
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2744

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  370
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  257
/* YYNRULES -- Number of rules.  */
#define YYNRULES  838
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1582

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   603

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,     2,     2,    30,     2,     2,
     361,   362,    28,    26,   366,    27,    32,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   363,   360,
      23,    22,    24,   367,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   368,     2,   369,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   364,     2,   365,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   714,   714,   715,   718,   720,   728,   737,   738,   739,
     746,   747,   748,   756,   757,   758,   759,   760,   761,   767,
     768,   775,   776,   780,   781,   788,   795,   796,   800,   804,
     811,   819,   820,   827,   828,   834,   843,   844,   848,   853,
     854,   858,   859,   863,   864,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   882,   883,   892,   893,   894,   895,
     898,   899,   900,   901,   902,   903,   907,   914,   917,   924,
     927,   930,   933,   937,   938,   942,   943,   944,   952,   957,
     958,   962,   969,   970,   976,   981,   985,   999,  1013,  1014,
    1018,  1019,  1020,  1031,  1033,  1035,  1039,  1040,  1041,  1042,
    1047,  1053,  1054,  1058,  1066,  1070,  1072,  1078,  1079,  1086,
    1087,  1091,  1097,  1101,  1111,  1113,  1117,  1118,  1119,  1120,
    1121,  1122,  1123,  1124,  1125,  1126,  1127,  1128,  1132,  1133,
    1134,  1135,  1139,  1140,  1141,  1142,  1143,  1147,  1153,  1157,
    1165,  1166,  1174,  1182,  1183,  1184,  1188,  1189,  1193,  1198,
    1199,  1203,  1205,  1213,  1217,  1218,  1224,  1231,  1232,  1233,
    1237,  1245,  1251,  1252,  1253,  1257,  1258,  1262,  1263,  1264,
    1265,  1266,  1267,  1273,  1274,  1275,  1279,  1280,  1284,  1285,
    1291,  1292,  1295,  1297,  1301,  1302,  1306,  1324,  1325,  1326,
    1327,  1328,  1329,  1337,  1340,  1343,  1346,  1350,  1351,  1354,
    1357,  1361,  1365,  1370,  1376,  1383,  1388,  1393,  1398,  1402,
    1406,  1410,  1419,  1427,  1431,  1438,  1439,  1440,  1445,  1449,
    1456,  1463,  1467,  1475,  1476,  1477,  1482,  1486,  1489,  1490,
    1491,  1492,  1493,  1494,  1495,  1500,  1505,  1513,  1520,  1527,
    1535,  1537,  1539,  1541,  1543,  1545,  1547,  1550,  1554,  1560,
    1561,  1562,  1566,  1567,  1573,  1575,  1577,  1579,  1581,  1583,
    1587,  1591,  1594,  1598,  1599,  1600,  1604,  1605,  1606,  1614,
    1614,  1624,  1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,
    1636,  1637,  1638,  1639,  1640,  1661,  1672,  1673,  1680,  1681,
    1688,  1697,  1701,  1705,  1729,  1730,  1734,  1747,  1747,  1763,
    1764,  1767,  1768,  1772,  1775,  1784,  1797,  1798,  1799,  1800,
    1801,  1805,  1813,  1814,  1815,  1816,  1817,  1821,  1824,  1825,
    1826,  1830,  1833,  1842,  1845,  1846,  1847,  1848,  1852,  1853,
    1854,  1858,  1859,  1860,  1861,  1865,  1866,  1867,  1868,  1872,
    1873,  1877,  1878,  1882,  1889,  1890,  1891,  1892,  1899,  1900,
    1903,  1904,  1911,  1923,  1924,  1928,  1929,  1933,  1934,  1935,
    1936,  1937,  1941,  1942,  1943,  1947,  1948,  1949,  1950,  1951,
    1952,  1953,  1954,  1955,  1956,  1957,  1961,  1962,  1972,  1976,
    1999,  2013,  2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,
    2022,  2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,  2034,
    2035,  2036,  2037,  2038,  2039,  2040,  2041,  2043,  2044,  2045,
    2047,  2049,  2051,  2053,  2054,  2055,  2056,  2057,  2067,  2068,
    2069,  2070,  2071,  2072,  2073,  2075,  2076,  2081,  2104,  2105,
    2106,  2107,  2108,  2109,  2113,  2116,  2117,  2118,  2126,  2133,
    2142,  2143,  2147,  2153,  2163,  2172,  2178,  2183,  2190,  2195,
    2201,  2202,  2203,  2211,  2212,  2213,  2214,  2215,  2221,  2233,
    2234,  2235,  2236,  2239,  2241,  2245,  2249,  2260,  2261,  2262,
    2263,  2264,  2265,  2268,  2270,  2273,  2275,  2278,  2281,  2286,
    2287,  2288,  2292,  2293,  2297,  2298,  2301,  2320,  2326,  2350,
    2351,  2352,  2353,  2354,  2365,  2366,  2367,  2368,  2369,  2370,
    2371,  2372,  2373,  2374,  2375,  2376,  2377,  2378,  2379,  2380,
    2381,  2382,  2383,  2384,  2385,  2386,  2387,  2388,  2389,  2390,
    2391,  2392,  2393,  2394,  2395,  2396,  2397,  2398,  2399,  2404,
    2405,  2406,  2407,  2408,  2409,  2410,  2411,  2412,  2413,  2414,
    2415,  2416,  2417,  2428,  2438,  2439,  2443,  2444,  2445,  2446,
    2447,  2448,  2449,  2450,  2453,  2468,  2471,  2473,  2477,  2478,
    2479,  2480,  2481,  2482,  2483,  2484,  2485,  2486,  2486,  2487,
    2487,  2488,  2489,  2490,  2494,  2495,  2499,  2507,  2509,  2513,
    2514,  2515,  2519,  2520,  2523,  2525,  2528,  2529,  2530,  2531,
    2532,  2533,  2534,  2535,  2536,  2537,  2538,  2541,  2563,  2564,
    2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,  2573,  2574,
    2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,  2584,
    2585,  2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,
    2595,  2596,  2597,  2598,  2599,  2600,  2603,  2605,  2608,  2610,
    2619,  2621,  2622,  2625,  2627,  2631,  2632,  2635,  2645,  2668,
    2670,  2674,  2674,  2677,  2679,  2682,  2684,  2688,  2692,  2693,
    2698,  2701,  2704,  2709,  2712,  2717,  2720,  2724,  2728,  2731,
    2732,  2733,  2734,  2735,  2736,  2737,  2738,  2744,  2751,  2752,
    2753,  2758,  2759,  2765,  2772,  2773,  2774,  2775,  2776,  2777,
    2778,  2779,  2780,  2781,  2782,  2783,  2784,  2788,  2789,  2790,
    2795,  2796,  2797,  2798,  2799,  2802,  2803,  2804,  2805,  2806,
    2807,  2808,  2811,  2813,  2816,  2818,  2822,  2834,  2841,  2848,
    2849,  2850,  2851,  2852,  2855,  2864,  2872,  2879,  2880,  2884,
    2889,  2895,  2898,  2903,  2904,  2905,  2906,  2907,  2910,  2917,
    2917,  2917,  2917,  2917,  2917,  2917,  2917,  2917,  2917,  2917,
    2917,  2917,  2917,  2917,  2918,  2918,  2918,  2918,  2918,  2918,
    2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,
    2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,
    2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,
    2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,
    2919,  2919,  2919,  2919,  2919,  2919,  2919,  2919,  2919,  2920,
    2920,  2920,  2920,  2921,  2921,  2921,  2922,  2922,  2922,  2922,
    2922,  2923,  2923,  2924,  2925,  2926,  2927,  2928,  2929,  2930,
    2931,  2932,  2933,  2934,  2934,  2934,  2934,  2934,  2934
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE",
  "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT", "LOG", "SYSLOG",
  "ALL", "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR", "AUTH",
  "FATAL", "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD", "SHORT",
  "LONG", "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT",
  "CONFIGURE", "DOWN", "KERNEL", "PERSIST", "SCAN", "TIME", "LEARN",
  "DEVICE", "ROUTES", "GRACEFUL", "RESTART", "KRT_SOURCE", "KRT_METRIC",
  "TABLE", "KRT_PREFSRC", "KRT_REALM", "ROUTER", "ID", "PROTOCOL",
  "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT", "INTERFACE", "IMPORT",
  "EXPORT", "FILTER", "NONE", "STATES", "FILTERS", "RECEIVE", "LIMIT",
  "ACTION", "WARN", "BLOCK", "DISABLE", "KEEP", "FILTERED", "PASSWORD",
  "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS", "INTERFACES",
  "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS", "PREEXPORT", "NOEXPORT",
  "GENERATE", "ROA", "LISTEN", "BGP", "V6ONLY", "DUAL", "ADDRESS",
  "PASSWORDS", "DESCRIPTION", "SORTED", "RELOAD", "IN", "OUT", "MRTDUMP",
  "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC", "CLASS", "DSCP", "WAIT",
  "MAX", "FLUSH", "AS", "SHOW", "STATUS", "SUMMARY", "ROUTE", "SYMBOLS",
  "ADD", "DELETE", "DUMP", "RESOURCES", "SOCKETS", "NEIGHBORS",
  "ATTRIBUTES", "EVAL", "ECHO", "ENABLE", "FUNCTION", "PRINT", "PRINTN",
  "UNSET", "RETURN", "ACCEPT", "REJECT", "QUITBIRD", "INT", "BOOL", "IP",
  "PREFIX", "PAIR", "QUAD", "EC", "SET", "STRING", "BGPMASK", "BGPPATH",
  "CLIST", "ECLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT",
  "RO", "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE",
  "SCOPE", "CAST", "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED",
  "CONTAINS", "RESET", "PREPEND", "FIRST", "LAST", "MATCH", "ROA_CHECK",
  "EMPTY", "WHERE", "BFD", "MIN", "IDLE", "RX", "TX", "INTERVAL",
  "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL", "SESSIONS", "HOLD",
  "CONNECT", "RETRY", "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF",
  "DEFAULT", "PATH", "METRIC", "START", "DELAY", "FORGET", "AFTER",
  "BGP_PATH", "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "ALLOW", "PATHS", "AWARE",
  "OSPF", "AREA", "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG",
  "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB", "TICK", "COST", "COST2",
  "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY", "DEAD", "TYPE",
  "BROADCAST", "BCAST", "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP",
  "POINTOMULTIPOINT", "PTMP", "SIMPLE", "AUTHENTICATION", "STRICT",
  "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL",
  "LINK", "ONLY", "BUFFER", "LARGE", "NORMAL", "STUBNET", "TAG",
  "EXTERNAL", "LSADB", "ECMP", "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY",
  "GLOBAL", "LSID", "INSTANCE", "REAL", "NETMASK", "LENGTH", "MERGE",
  "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE", "TRANSPARENT",
  "RIP", "INFINITY", "PERIOD", "GARBAGE", "MULTICAST", "QUIET", "NOLISTEN",
  "VERSION1", "PLAINTEXT", "MD5", "HONOR", "NEVER", "ALWAYS", "RIP_METRIC",
  "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH", "BLACKHOLE", "UNREACHABLE",
  "';'", "'('", "')'", "':'", "'{'", "'}'", "','", "'?'", "'['", "']'",
  "$accept", "config", "conf_entries", "definition", "expr", "expr_us",
  "bool", "ipa", "ipa_scope", "ipa_port", "prefix", "prefix_or_ipa",
  "pxlen", "datetime", "text", "text_or_none", "log_config", "syslog_name",
  "log_file", "log_mask", "log_mask_list", "log_cat", "mrtdump_base",
  "timeformat_which", "timeformat_spec", "timeformat_base",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM",
  "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name",
  "cfg_timeout", "kern_proto_start", "kern_item", "kif_proto_start",
  "kif_item", "kern_sys_item", "rtrid", "idval", "listen", "listen_opts",
  "listen_opt", "gr_opts", "tab_sorted", "newtab", "roa_table_start",
  "roa_table_opts", "roa_table", "proto_start", "proto_name", "proto_item",
  "imexport", "limit_action", "limit_spec", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_list_nopx",
  "iface_patt_init", "iface_patt", "tos", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "mrtdump_mask", "mrtdump_list", "mrtdump_flag",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "cmd_SHOW_STATUS",
  "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL",
  "optsym", "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY",
  "cmd_SHOW_ROUTE", "r_args", "export_mode", "cmd_SHOW_ROA", "roa_args",
  "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args", "roa_table_arg",
  "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA", "cmd_DUMP_RESOURCES",
  "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS",
  "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS",
  "cmd_EVAL", "cmd_ECHO", "echo_mask", "echo_size", "cmd_DISABLE",
  "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD", "cmd_RELOAD_IN",
  "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP", "cmd_RESTRICT",
  "proto_patt", "proto_patt2", "filter_def", "$@1", "filter_eval", "type",
  "one_decl", "decls", "declsn", "filter_body", "filter", "where_filter",
  "function_params", "function_body", "function_def", "$@2", "cmds",
  "cmds_int", "block", "fipa", "set_atom", "switch_atom", "pair_expr",
  "pair_atom", "pair_item", "ec_expr", "ec_kind", "ec_item", "set_item",
  "switch_item", "set_items", "switch_items", "fprefix_s", "fprefix",
  "fprefix_set", "switch_body", "bgp_path_expr", "bgp_path",
  "bgp_path_tail1", "bgp_path_tail2", "constant", "constructor", "rtadot",
  "function_call", "symbol", "static_attr", "term", "break_command",
  "print_one", "print_list", "var_listn", "var_list", "cmd",
  "bfd_proto_start", "bfd_proto_item", "bfd_proto_opts", "bfd_proto",
  "bfd_iface_start", "bfd_iface_item", "bfd_iface_opts",
  "bfd_iface_opt_list", "bfd_iface", "bfd_multihop", "bfd_neigh_iface",
  "bfd_neigh_local", "bfd_neigh_multihop", "bfd_neighbor",
  "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start", "bgp_proto",
  "ospf_proto_start", "ospf_proto", "ospf_proto_item", "ospf_area_start",
  "ospf_area", "ospf_area_opts", "ospf_area_item", "$@3", "$@4",
  "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_base", "pref_opt", "nbma_list", "nbma_eligible", "nbma_item",
  "ospf_iface_start", "ospf_instance_id", "ospf_iface_patt_list", "$@5",
  "ospf_iface_opts", "ospf_iface_opt_list", "ospf_iface", "opttext",
  "cmd_SHOW_OSPF", "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "rip_cfg_start",
  "rip_cfg", "rip_auth", "rip_mode", "rip_iface_item", "rip_iface_opts",
  "rip_iface_opt_list", "rip_iface_init", "rip_iface",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "cmd_SHOW_STATIC", "conf", "cli_cmd",
  "proto", "kern_proto", "kif_proto", "dynamic_attr", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,    43,    45,    42,    47,
      37,    33,    46,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
      59,    40,    41,    58,   123,   125,    44,    63,    91,    93
};
# endif

#define YYPACT_NINF -1224

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1224)))

#define YYTABLE_NINF -441

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-441)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     141,  2515,    80,   595,   459,   694,   190,   459,   459,   487,
     459,   214,   210,   679,   215,   230,   739,  1400,    51,   459,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,   352,
     942,   192,   588,   305,   382,   345, -1224, -1224,   395,   362,
     325,   319,  1400,   436, -1224, -1224, -1224, -1224, -1224,   470,
     470, -1224, -1224, -1224, -1224,   106, -1224,  1252, -1224,   470,
    2203, -1224, -1224, -1224,   470, -1224,   470,  2274,   470,  2074,
     470,  2108,   470,  2005,   470,  2059, -1224, -1224,  2339,  2366,
   -1224, -1224, -1224,    85, -1224,   478,   505,   518,   478,   462,
   -1224,   550,   599,   459,   459,   623,   123, -1224,   511,   693,
      76, -1224,   631,   635, -1224, -1224,   424,   485,   644,   457,
     457,   667,   673,   688,   704,   718,   744,   750,    11, -1224,
   -1224, -1224,   668,   425, -1224,   547,    18,    16,  1400, -1224,
     438,   445,   464, -1224, -1224,   468,   491,   498,  1011,    55,
   -1224, -1224, -1224, -1224, -1224,  1984, -1224,  2666, -1224, -1224,
    1191,   773,   897,   879, -1224, -1224,   842, -1224, -1224,   -12,
      85,   171, -1224, -1224, -1224, -1224,   477,   545,   776,   785,
     541, -1224,   900, -1224,   123,   560,  2691, -1224,   826,   570,
     571, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224,   582,    85,   929,   874,   171,   774, -1224,   309,   529,
     858,   706,   123, -1224,   600,   606,   607,   615,   100,   893,
     620,   756,   706,   774,   895,   715,    82,   880,   774,    72,
     457,   375,   926,   782,   933,   786,   778,   330,   777,   779,
     533,   760,   759,   774,   761,   758,   768,   107,     0,   787,
     742,   752,   774,   799, -1224,   676,   675,   567,   774,   958,
     171,   774,   724, -1224, -1224,   690,   687, -1224,   696,   972,
     456, -1224,   701,   698,   171,   982, -1224,   706,   705,   -30,
     171,   171,   993,  -163, -1224,   708,   710, -1224,   707,   709,
     766,   457,   992, -1224,   719,   527,   723,  1012,   774,  1022,
     774,  1020,  1019, -1224,   737,   740,   741,  1027,  1082, -1224,
     743,   746, -1224, -1224,   872,  1104,   462, -1224, -1224,  1106,
     171,  1107, -1224, -1224,  1108,  1109, -1224, -1224, -1224,   160,
    1111,  1097,  1114, -1224, -1224,   783,  1115, -1224,  1116,   551,
   -1224, -1224,  2398,  1137,   644, -1224,   644,   644, -1224,   387,
     427,  1133,  1136, -1224, -1224,    26,  1000,  1005, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224,    11, -1224,    11,  1400,    11,
      11,  1140, -1224,  1143,   714,  1129,   950,  1135,    16,    16,
    1142,  1146,  1400,  1400,  1400,  1400,  1400,  1153, -1224, -1224,
    1159, -1224,   809,    90, -1224, -1224, -1224, -1224,   815, -1224,
    1177, -1224, -1224, -1224,  -206,    27, -1224,   127, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224,  1400,  1400,  1400,  1400,  1400,  1400,
    1400,  1400,  1400,  1400,  1400,  1400,  1400,   988, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224,   447, -1224, -1224,
    1182, -1224,  1400,   706, -1224, -1224,  1191,   829, -1224, -1224,
   -1224,  1400, -1224,   171,   757,   780, -1224,   171, -1224, -1224,
   -1224, -1224, -1224, -1224,   841,  2565, -1224,    94,   843, -1224,
     844,  1185, -1224, -1224,   -81, -1224, -1224, -1224, -1224,   567,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,  1300,
   -1224,   409,  1105,  1400, -1224, -1224,   409, -1224,   409, -1224,
   -1224, -1224, -1224, -1224, -1224,  1138,  1139,   664, -1224,  1163,
     854,   856,   171,   134,   966,   774,   457,   860, -1224,   869,
    1201,   171,  1089,   171,  1161,   171,  1173,    95,   171,   171,
     774,  1174,   887,  1165,   890,   774,   891,   774,    47,   774,
     929,   774,   892,   896,   774,   774,   774,   899,  1117, -1224,
   -1224, -1224, -1224,   774, -1224,  1166,   774, -1224, -1224, -1224,
    1246,   906,   907, -1224, -1224,   908,   171, -1224,   917, -1224,
    1175, -1224, -1224, -1224,   918,   919,   921,   171,   934,   937,
     938, -1224, -1224,    81, -1224,   774, -1224,   929, -1224, -1224,
     700, -1224,   457, -1224,  1058, -1224, -1224, -1224,   171, -1224,
     171, -1224,   774,   774, -1224, -1224, -1224,   171, -1224,   457,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,   483, -1224,
   -1224,  1296, -1224, -1224, -1224, -1224, -1224, -1224, -1224,   496,
   -1224, -1224, -1224, -1224,  1297, -1224, -1224, -1224,  1282, -1224,
   -1224,  1288,   457, -1224, -1224,  1285,  1286, -1224,  1300, -1224,
   -1224, -1224, -1224,   457, -1224, -1224, -1224,  1287, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224,  1304,  1293,  1293,
    1030,   644,  1293,   644,  1293, -1224, -1224,   171,   457, -1224,
    1307,  1308, -1224, -1224,   753, -1224, -1224, -1224, -1224,   115,
   -1224,   946, -1224,  1298, -1224, -1224, -1224, -1224,   238,   263,
     288,   846,   515,   120, -1224,  1400, -1224,  1400, -1224,  1321,
     963,   964,   901,    66,    92, -1224, -1224, -1224,  1316,  1314,
   -1224,  1653,  1653,  1653,  2051,  2051,  1653,  1653,  1653,  1653,
     592,   592,  1146,  1146, -1224,   973, -1224, -1224, -1224, -1224,
    1191, -1224,  1877, -1224,   500, -1224,  1141,  1315, -1224, -1224,
   -1224, -1224,   978, -1224,   979, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,   109,   980,
     981, -1224, -1224,   171, -1224, -1224,   457, -1224, -1224, -1224,
     955,  2565, -1224,   457, -1224, -1224,  1317, -1224,   997, -1224,
   -1224, -1224, -1224,  1247, -1224,   774,  2691, -1224, -1224,   862,
     171,   171,   171,   987,  1007,   774, -1224, -1224,  1013,  1014,
    1016,  1017,   774,  1021,  1023, -1224, -1224,  1346,  1330,  1024,
     171,  1026,   171,  1033,   171,  1034,  1035,  1042,  1044,  1051,
     171, -1224,   567, -1224,  1052, -1224,  1054,  1061,  1063,  1064,
    1065,  1070,  1077, -1224, -1224,  1078,  1079,  1083, -1224,   131,
   -1224,   171, -1224,  1936,  1084, -1224, -1224, -1224,  1085,    -6,
   -1224,  1090,  1094, -1224, -1224, -1224,  1098, -1224, -1224, -1224,
     171,   544,   579,  1096,  1102,  1120, -1224,  1201, -1224,   457,
    1060,  1058, -1224, -1224, -1224, -1224, -1224,    26, -1224, -1224,
   -1224,   872, -1224, -1224,   160, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224,  1439,  1463, -1224, -1224,
     567, -1224,   567,  1459, -1224, -1224,   567,  1293,  1478,  1293,
    1479, -1224, -1224,  1340,  1343, -1224,  1400, -1224,  1461,  1400,
    1400,  1400, -1224,  1400, -1224,  1400,   540,  1424,  1400,  1256,
    1400, -1224, -1224,  1400, -1224, -1224,  1123,   668, -1224,  1400,
   -1224, -1224, -1224, -1224, -1224, -1224,   997, -1224, -1224, -1224,
    2565,   350, -1224, -1224, -1224,  1130,  1144, -1224,  1350, -1224,
     749, -1224,   721, -1224, -1224, -1224, -1224,   457, -1224, -1224,
    1132,  1134,  1145,  1147, -1224, -1224,  1156, -1224, -1224, -1224,
   -1224,  1157, -1224, -1224, -1224,   171,  1356, -1224,  1164, -1224,
    1167, -1224,  1168, -1224, -1224, -1224, -1224, -1224,  1169,  1171,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224,  1172, -1224, -1224,   774,   258,   222, -1224,  1189,
     457, -1224, -1224,   542, -1224,  1178, -1224,  1176, -1224, -1224,
   -1224, -1224, -1224,  1175, -1224,  1180,  1482,  1482,  1482,  1482,
   -1224, -1224, -1224, -1224,  1201,   171,  1060, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224,  1520, -1224,  1522, -1224,  1518,
    1519, -1224, -1224,  1486,  1536,  1587,  1617,   585,  1400, -1224,
   -1224,  2691,  1179,  1186,  2691,   901,  1527,  1642, -1224,     7,
   -1224,  1513, -1224, -1224,  1190,  1400, -1224, -1224, -1224,  1400,
    1400,  1188,    19,  1984,  1194,  1335, -1224,  2565, -1224,  1540,
     457, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
    1202, -1224,    22, -1224, -1224,   171, -1224, -1224, -1224, -1224,
   -1224,   171, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224,   171,   171,   774,   171, -1224,  1203,   567, -1224, -1224,
    1205,  1206,   171, -1224, -1224,   171,  1207,   401, -1224,    81,
   -1224,  1212,  1214,  1215,  1217, -1224, -1224, -1224, -1224,   511,
     511, -1224, -1224, -1224, -1224,  1400,  1682,  1530,  1372,  1213,
   -1224,  1400,   714,  1400, -1224,  1902,  2547,   633, -1224, -1224,
    1557,   451, -1224,  2691,  1216,  1221, -1224,  1440, -1224,   997,
    1202, -1224, -1224,  1567,   706,  1367,  1229,  1230,   997,  1227,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224,    38,   171,  1322,   358, -1224,  1233, -1224,    81,    81,
      81,    81,  1597,  1599,  1719, -1224,  1242,  1243,    15, -1224,
    1928,  1244,  1958,  2033, -1224,   925, -1224,  1400,  1400,   727,
    1335, -1224,  1603, -1224,    -2, -1224, -1224,   457,  1402, -1224,
   -1224,  1176, -1224, -1224,     5,    75,    25,   755,   171,   171,
     171, -1224, -1224,   287, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,  1400, -1224,
    1400, -1224, -1224, -1224, -1224,  1259,   350,  1441, -1224,    60,
    1983,  2008,  1261,  1269,  1294,  1295,  1299, -1224,  1312,   774,
     665,  1432,   171,   171, -1224,  1313, -1224,   774, -1224, -1224,
    2320, -1224, -1224, -1224,   -67,   774,   171,   774, -1224,  1323,
   -1224,   171,   171,   171,  1412,    77,   -27, -1224, -1224,  1324,
   -1224, -1224, -1224,  1344, -1224,  1292,  1325,  1326,  1332,   925,
      43, -1224, -1224, -1224,   815, -1224, -1224,  1681, -1224, -1224,
   -1224,   270, -1224, -1224,  1400,  1400,  1400,  1400, -1224, -1224,
   -1224,  1444,  1473,  1483,   798, -1224, -1224, -1224, -1224,  1386,
     171,  1337,   774,  1388,   143,  1428,   774,   774,   171,   171,
     171,  1476,   171,   213,  1336,  1383,   -26,  1418,   171,  1394,
    1422, -1224, -1224,  1358, -1224,   171,  1359, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224,   171,   171, -1224, -1224, -1224, -1224,
   -1224, -1224,  1400, -1224, -1224, -1224, -1224, -1224,  1747,   116,
      43,   139,  1772,  1797,  1827,  1852,   171,   171,   171, -1224,
   -1224, -1224,   774, -1224, -1224, -1224,    31,   171,   171, -1224,
     674, -1224, -1224, -1224, -1224, -1224,   171, -1224,   171, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,   774, -1224,
   -1224, -1224,   774, -1224,   171,   774, -1224, -1224, -1224, -1224,
   -1224,  1360, -1224,  1400, -1224, -1224, -1224,  1361,  1363,  1364,
    1365, -1224, -1224, -1224, -1224,    23, -1224, -1224, -1224, -1224,
   -1224,  1407, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
    1747, -1224, -1224, -1224, -1224,  1419, -1224, -1224, -1224, -1224,
    1374, -1224
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    73,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   378,     0,     0,
     754,   755,   756,   757,   758,   759,   760,   761,   762,   763,
     764,   765,   766,   767,   768,   769,   770,   771,   772,   773,
     774,   775,   776,   777,   778,   779,   780,   781,   782,   783,
     784,   785,   786,   787,   788,   789,   790,   791,   792,   793,
     794,   795,   796,   797,   798,   799,     3,     1,     2,     0,
       0,     0,     0,     0,     0,     0,   109,   110,     0,     0,
       0,     0,   378,     0,   739,   740,   741,   742,   743,   111,
     111,   744,   745,   746,   747,   107,   748,     0,   750,   111,
     114,   751,   752,   753,   111,   803,   111,   114,   111,   114,
     111,   114,   111,   114,   111,   114,     5,   749,   114,   114,
     263,   265,   264,     0,    74,    73,     0,     0,    73,    75,
      72,     0,     0,     0,     0,     0,     0,   262,   235,   267,
       0,   219,     0,     0,   202,   227,     0,   198,   198,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   361,   365,
     374,   371,   305,   380,   368,     0,     0,   364,   378,   410,
       0,     0,     0,   366,   367,     0,     0,     0,   378,     0,
     369,   370,   375,   408,   409,     0,   407,     0,   250,   249,
       0,   252,     0,     0,    32,    31,    37,    40,    38,     0,
       0,     0,    59,    58,    57,    56,     0,     0,     0,   101,
       0,   269,     0,    94,     0,     0,   271,   297,   112,     0,
       0,   105,    78,    84,   156,   488,   458,   543,   677,   683,
     718,     0,     0,     0,     0,     0,    18,   160,     0,     0,
       0,     0,     0,   802,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    18,     0,     0,     0,     0,    18,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    18,     0,     0,     0,     0,     0,     0,
       0,     0,    18,     0,   804,     0,     0,     0,    18,     0,
       0,    18,     0,   805,   546,     0,     0,   553,     0,     0,
       0,   806,     0,     0,     0,     0,   716,     0,     0,     0,
       0,     0,     0,     0,   807,     0,     0,   181,   185,     0,
       0,     0,     0,   808,     0,     0,     0,     0,    18,     0,
      18,     0,     0,   800,     0,     0,     0,     0,    34,   801,
       0,     0,   163,   162,     0,     0,    75,    69,    70,     0,
      76,     0,   256,   254,     0,     0,   257,   174,   173,     0,
       0,     0,     0,   266,   268,   267,     0,   199,     0,   223,
     194,   193,     0,     0,   198,   197,   198,   198,   668,   198,
     198,     0,     0,    19,    20,     0,     0,     0,   245,   246,
     242,   240,   241,   243,   244,   361,   380,   361,   378,   361,
     361,     0,   353,     0,   378,     0,     0,     0,   364,   364,
       0,   405,   378,   378,   378,   378,   378,     0,   324,   325,
       0,   327,     0,     0,   306,   309,   307,   311,   378,   308,
     333,   331,   332,   339,     0,   344,   348,     0,   821,   816,
     817,   818,   819,   381,   820,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   823,   826,   825,   822,   824,   827,
     828,   829,   832,   830,   831,   833,   834,   835,   836,   837,
     838,   411,   412,   247,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,     0,    45,    46,
      47,    48,    49,    50,    51,    52,    53,     0,    43,   253,
       0,   255,   378,     0,    39,    41,     0,     0,   140,     7,
       9,   378,   141,    60,     0,     0,    66,     0,   102,   103,
      90,    91,    92,   152,     0,   286,   104,     0,     0,    55,
       0,     0,   809,   813,     0,   157,   117,   139,   125,     0,
     115,    14,    16,    15,    17,    13,   116,   142,   130,   286,
     131,     0,     0,   378,   119,   129,     0,   120,     0,   127,
     118,   158,   159,   463,   489,     0,     0,    18,   501,     0,
       0,     0,     0,    18,     0,    18,     0,     0,   502,     0,
      21,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      18,     0,     0,     0,     0,    18,     0,    18,     0,    18,
       0,    18,     0,     0,    18,    18,    18,     0,     0,   490,
     544,   554,   547,    18,   552,   549,    18,   545,   556,   678,
       0,     0,     0,   679,   684,     0,     0,   142,     0,   186,
     182,   699,   697,   698,     0,     0,     0,     0,     0,     0,
       0,   685,   692,   187,   719,    18,   724,     0,   720,   734,
       0,   733,     0,   737,     0,   735,   736,   723,     0,    79,
       0,    81,    18,    18,   811,   812,   810,     0,    33,     0,
     815,   814,   168,   167,   169,   171,   172,   170,     0,   165,
     260,     0,    71,    77,    67,   258,   259,   178,   179,     0,
     176,   261,   236,   239,     0,   195,   200,   218,     0,   225,
     224,     0,     0,   201,   208,     0,     0,   216,   286,   210,
     209,   213,   214,     0,   215,   217,   203,     0,   207,   226,
     234,   228,   231,   232,   230,   233,   229,     0,   659,   659,
       0,   198,   659,   198,   659,   660,   738,     0,     0,    25,
       0,     0,   357,   358,     0,   359,   360,   355,   343,   438,
     441,     0,   418,     0,   419,   362,   363,   356,     0,     0,
       0,     0,     0,     0,   326,   378,   391,   378,   320,   318,
       0,     0,   317,     0,     0,   372,   345,   346,     0,     0,
     373,   403,   401,   399,   396,   397,   398,   400,   402,   404,
     392,   393,   394,   395,   413,     0,   414,   416,   417,   251,
       0,   248,     0,    36,     0,    35,     0,     0,    62,    63,
      64,    65,     0,   142,     0,    88,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,     0,     0,
       0,   270,   290,     0,    98,    99,     0,    93,    95,    54,
       0,   286,   113,     0,   108,   126,   146,   149,   161,   291,
     292,   128,   138,   132,   122,    18,   293,   123,   121,   114,
       0,     0,     0,     0,     0,    18,   527,   529,     0,     0,
       0,     0,    18,     0,     0,   542,   503,     0,    23,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   495,     0,   496,     0,   525,     0,     0,     0,     0,
       0,     0,     0,   509,   510,     0,     0,     0,   531,     0,
     548,     0,   551,     0,     0,   681,   682,   687,     0,   714,
     696,     0,     0,   691,   686,   688,     0,   694,   695,   693,
       0,     0,     0,     0,     0,     0,   730,    21,   732,     0,
     727,   731,    87,    80,    82,    83,    85,    27,    26,    86,
     164,     0,    68,   175,     0,   196,   222,   221,   220,   205,
     212,   206,   204,   211,   487,   658,     0,     0,   667,   676,
       0,   674,     0,     0,   671,   669,     0,   659,     0,   659,
       0,    28,    29,     0,     0,   354,   378,   427,     0,   378,
     378,   378,   406,   378,   425,   378,     0,     0,   378,   378,
     378,   310,   305,   378,   334,   340,     0,     0,   349,   378,
      44,     6,    42,     8,    61,   100,   153,    89,   285,   284,
     286,   378,    97,    96,   295,   288,     0,   298,     0,   147,
       0,   142,     0,   137,   124,   466,   466,     0,   465,   459,
       0,     0,     0,     0,   538,   537,     0,   528,   532,   533,
     534,     0,   524,   518,    22,     0,     0,   491,     0,   497,
       0,   500,     0,   505,   504,   517,   516,   511,     0,     0,
     526,   514,   506,   507,   508,   530,   540,   513,   512,   541,
     515,   535,     0,   550,   648,    18,     0,    18,   567,     0,
       0,   569,   559,    18,   555,     0,   573,   649,   680,   690,
     712,   717,   180,   182,   689,     0,     0,     0,     0,     0,
     184,   721,   722,   729,    21,     0,   728,   166,   177,   662,
     661,   675,   670,   672,   673,     0,   663,     0,   665,     0,
       0,   439,   420,     0,     0,     0,     0,     0,   378,   376,
     319,   317,     0,     0,   323,     0,     0,     0,   287,     0,
     431,     0,   432,   433,     0,   378,   429,   430,   428,   378,
     378,     0,   378,     0,     0,   378,   301,     0,   294,     0,
     143,   144,   148,   150,   135,   133,   134,   136,   142,   460,
     475,   461,   479,   462,   464,     0,   520,   539,   522,   523,
      24,     0,   492,   499,   498,   519,   494,   536,   142,   572,
     560,     0,     0,    18,     0,   558,     0,     0,   576,   571,
     575,     0,     0,   565,   557,     0,   583,   705,   183,   187,
      30,     0,     0,     0,     0,   725,   726,   664,   666,   235,
     235,   424,   422,   423,   421,   378,     0,   321,   378,     0,
     415,   378,   378,   378,   378,     0,     0,     0,   296,   302,
       0,     0,   451,   434,   436,     0,   289,     0,   145,   151,
     475,   473,   478,     0,     0,   482,     0,     0,   651,   655,
     562,   563,   561,   564,   636,   597,   577,   636,   566,   650,
     584,     0,     0,     0,     0,   715,     0,   192,   187,   187,
     187,   187,     0,     0,     0,   377,     0,     0,     0,   347,
       0,     0,     0,     0,   445,   378,   350,   378,   378,     0,
     378,   450,     0,   477,     0,   480,   481,     0,   484,   521,
     493,   649,   653,   657,     0,     0,     0,   586,     0,     0,
       0,   708,   706,    18,   700,   701,   702,   703,   704,   707,
     713,   188,   189,   190,   191,   237,   238,   426,   378,   330,
     378,   328,   444,   379,   448,     0,   378,   442,   303,     0,
       0,     0,     0,     0,     0,     0,     0,   437,     0,    18,
       0,     0,     0,     0,   476,     0,   483,    18,   486,   652,
       0,   568,   639,   637,   640,    18,     0,    18,   574,     0,
     570,     0,     0,     0,     0,     0,     0,   582,   596,     0,
     154,   155,   709,     0,   710,     0,     0,     0,     0,   378,
     378,   312,   316,   314,   378,   452,   315,   337,   335,   336,
     341,     0,   447,   446,   378,   378,   378,   378,   453,   106,
     472,     0,     0,     0,     0,   467,   471,   474,   485,     0,
       0,     0,    18,     0,     0,     0,    18,    18,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   656,   635,     0,   641,     0,     0,   580,   581,   579,
     578,   590,   588,   587,     0,     0,   591,   593,   594,   595,
     585,   711,   378,   329,   449,   304,   443,   352,   317,     0,
     378,     0,     0,     0,     0,     0,     0,     0,     0,    10,
      11,    12,    18,   602,   643,   633,     0,     0,     0,   628,
      18,   634,   618,   598,   601,   599,     0,   616,     0,   603,
     605,   606,   607,   608,   609,   610,   611,   612,    18,   622,
     623,   624,    18,   600,     0,    18,   654,   642,   638,   589,
     592,     0,   313,   378,   338,   351,   342,     0,     0,     0,
       0,   468,   469,   470,   619,     0,   626,   625,   627,   629,
     630,     0,   631,   615,   604,   614,   617,   620,   613,   322,
       0,   457,   455,   456,   454,   645,   621,   644,   632,   646,
       0,   647
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1224, -1224, -1224, -1224,  -138,  -558,  -240,  -233,  -789, -1224,
    -147,  -698, -1224,  -120,   -77, -1224, -1224, -1224, -1224, -1224,
    1226,   935, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224,   549,  1390, -1224, -1224, -1224, -1224, -1224, -1224,
    -286, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224,  2284,   -99,  1498, -1224,   216,  -346, -1224, -1224, -1224,
   -1224,   722,  -618, -1224, -1224, -1224,   294, -1224, -1224, -1224,
   -1224,   154, -1224,   788,    10, -1224,   795, -1149,   647,  -619,
   -1224,  -702, -1224, -1224, -1224, -1224,  -141, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224,  -342, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224,  1048,  1387, -1224, -1224, -1224, -1224,  -793,   734,   593,
    1237,  1055,  1392, -1224,   924, -1224, -1224, -1197, -1224,   357,
    -173,   994,   289,  -981,   789, -1223, -1134,  1607, -1162,  1003,
     296, -1224, -1224,  -174,  1010, -1224, -1224, -1224, -1224,   269,
     488, -1224, -1224, -1000, -1224,   -55,   627,   -17, -1224, -1224,
     481,   806,   561, -1105, -1224, -1224, -1224, -1224,   775, -1224,
   -1224,   552, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,   516,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224,   489, -1224, -1224,
   -1224, -1224, -1224,  -538, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224,   861, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1069
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    85,   545,  1435,   546,   385,   878,  1056,
     948,   949,   739,  1221,   198,   669,    86,   504,   199,   507,
     497,   498,    87,   206,   207,    88,    20,    21,    22,    23,
      24,    25,   129,   351,    89,   334,    90,   340,   335,    91,
     524,    92,   527,   838,    93,   519,    94,    95,   534,    96,
      97,   219,   244,   554,  1033,   854,   538,    98,   846,  1172,
    1030,   847,   848,  1260,   813,   814,  1331,    99,   100,   547,
     245,   345,   678,   679,   360,   689,   690,   316,   921,   317,
     318,   933,    26,    27,    28,    29,   381,    30,    31,    32,
     372,   717,    33,   369,   702,    34,   373,   362,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
     191,   500,    47,    48,    49,    50,    51,    52,    53,    54,
      55,   123,   366,   101,   525,   102,   828,   829,   830,  1026,
     850,   851,   555,   841,   832,   103,   530,  1161,  1162,  1357,
     180,   430,  1417,   769,   770,   431,  1143,   771,   432,   433,
    1420,   434,  1421,   181,   436,   437,  1359,   400,   182,   401,
     410,   183,   184,   185,  1164,   186,   471,  1141,  1165,  1254,
    1255,   750,   751,  1166,   104,  1040,   859,   105,  1178,  1375,
    1314,  1262,  1179,  1181,  1265,  1318,  1378,  1183,    56,   106,
     107,   108,   109,   295,   296,   297,   913,  1095,  1206,  1211,
    1209,  1210,  1325,  1389,  1096,  1327,  1399,  1097,  1463,  1324,
    1383,  1384,  1466,  1555,  1580,  1577,  1198,  1216,  1269,  1321,
    1380,  1323,  1199,   966,    57,    58,    59,    60,    61,    62,
      63,    64,   730,   110,   111,   112,   113,   634,  1339,  1286,
    1217,  1101,   627,   628,   114,   115,   325,   940,   941,   326,
      65,   116,    66,   117,   118,   119,   472
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     187,   611,   386,   387,   215,   435,   429,   382,   285,   919,
     294,   922,   302,   571,   315,   962,   324,  1140,   577,   336,
     341,  1163,  1350,   383,   384,  -300,   395,   580,   582,  1241,
     396,   408,   505,   596,  -300,  -300,  -300,  -300,  1149,   397,
     843,  1575,   607,   383,   384,   406,   509,  1025,   612,  -299,
     510,   615,  1263,   776,   777,   737,   638,  1249,  -299,  -299,
    -299,  -299,  1149,   512,   631,   216,  1410,  1477,  1529,  1150,
     424,   425,   426,   162,   427,  1411,  1412,  1413,  1002,   367,
      67,   424,   425,   426,  1002,   427,   188,   509,   659,   602,
     661,   510,   509,  1150,  1251,   189,   510,   540,   474,   475,
     476,   477,   478,   402,  1298,  1369,  1151,   424,   425,   426,
    1002,   427,   479,   480,   481,   482,   483,   484,   485,   486,
     342,   579,   487,   474,   475,   476,   477,   478,  1018,   343,
    1151,  1411,  1412,  1413,  1002,   833,  1418,   479,   480,   481,
     482,   483,   484,   485,   486,     1,   509,   487,  1113,   509,
     510,   411,   614,   510,  1411,  1412,  1413,  1002,   357,  1408,
     774,   423,  1163,   775,   559,   930,   625,   358,   541,   542,
     543,   544,   635,   636,   646,   570,  1328,  1329,  1398,  1152,
    1153,  1154,  1155,  1156,  1157,  1158,   509,   600,   639,   640,
     510,   967,  1475,   130,   978,  1016,   980,  1419,   885,  1159,
    1358,   931,  1160,  1152,  1153,  1154,  1155,  1156,  1157,  1158,
    1370,  1371,   683,  1487,  1372,  1373,  1406,   137,   834,   835,
     836,  1385,   368,  1159,   528,   716,  1160,   407,   509,   574,
     629,  1462,   510,   727,  1355,   728,   729,   509,   732,   734,
     565,   510,  1264,  1464,  1303,   932,   474,   475,   476,   477,
     478,  1465,   560,   845,   901,   687,   541,   542,   543,   544,
     479,   480,   481,   482,   483,   484,   485,   486,  1418,   603,
     487,   474,   475,   476,   477,   478,  1478,  1530,   897,  1479,
    1531,  1328,  1329,  1019,   844,   479,   480,   481,   482,   483,
     484,   485,   486,  1545,   688,   487,   474,   475,   476,   477,
     478,   935,   509,   200,  1358,  1163,   510,   898,   899,   201,
     479,   480,   481,   482,   483,   484,   485,   486,   632,   633,
     487,   541,   542,   543,   544,  1225,   886,   864,  1518,  1419,
    1330,   138,  1171,   871,   575,   873,   149,   566,   194,   195,
     402,   601,   402,   874,   402,   402,  1556,  1557,   869,   870,
     889,   150,   506,   548,   508,   894,  1163,   896,  1100,   900,
    1031,   902,  1386,  1374,   905,   906,   907,  1405,  1242,  1149,
    1381,   193,   398,   910,  1025,   807,   912,  1351,   399,   812,
    -300,   744,   208,   409,  -300,  1387,   536,   749,  1576,   738,
    1390,   778,   511,   383,   384,   758,   759,   760,   761,   762,
    1150,   209,   549,   550,  -299,   934,   375,   551,  -299,  1163,
    1163,   772,   552,   853,   211,   190,   428,   937,   853,   938,
     853,  1414,   944,   945,   509,  1415,   803,  1003,   510,   210,
     214,   731,   578,   511,   868,  1507,   947,  1151,   511,  1125,
    1388,  1127,   212,   879,   852,   881,   375,   883,   213,   344,
     887,   888,   766,   428,   837,   217,   767,   781,   782,   783,
     784,   785,   786,   787,   788,   789,   790,   791,   792,   793,
     221,   733,  1258,  1308,  1508,   383,   384,  1543,   120,   121,
     947,   986,   994,  1309,   922,   802,   995,   359,   918,   218,
    1163,  1081,   511,   779,   806,   511,   780,   513,   124,   926,
    1414,  1541,  1403,   122,   375,   982,   120,   121,   347,  1204,
    1152,  1153,  1154,  1155,  1156,  1157,  1158,  1287,   581,   553,
     942,   348,   943,   474,   475,   476,   477,   478,   350,   946,
    1159,   122,   511,  1160,   514,   515,   856,   479,   480,   481,
     482,   483,   484,   485,   486,  1201,  1202,   487,   474,   475,
     476,   477,   478,   352,   697,   958,   520,   509,   521,   522,
    1259,   510,   479,   480,   481,   482,   483,   484,   485,   486,
     588,   589,   487,   548,   511,   376,   541,   542,   543,   544,
    1268,  1203,   520,   511,   521,   522,  1341,  1342,  1343,  1344,
     977,   361,   979,   474,   475,   476,   477,   478,    68,   981,
     429,   429,   353,  1023,   989,   435,  1069,   479,   480,   481,
     482,   483,   484,   485,   486,  1034,  1281,   487,   133,   134,
     485,   486,   549,   550,   487,  1046,   356,   556,    69,   990,
     202,   698,  1051,  1490,   370,  1282,  1491,    70,   371,   377,
      71,   474,   475,   476,   477,   478,   374,   523,   511,   203,
    1106,    72,  1107,  1334,   991,   479,   480,   481,   482,   483,
     484,   485,   486,   375,   742,   487,   743,   699,   745,   746,
     388,    73,  1283,   204,   346,    74,   389,   349,    75,   509,
      76,    77,   700,   510,  1121,  1108,  1122,  1109,    78,   509,
    1124,   390,   649,   510,   701,  1022,  1028,   403,   541,   542,
     543,   544,  1335,  1336,  1337,  1338,  1114,   391,   541,   542,
     543,   544,   363,   364,   124,  -299,    79,    80,   383,   384,
     936,   392,  1041,  1042,  1043,   194,   195,   158,    81,   159,
     160,   161,   162,   163,   164,   205,   862,   365,  1284,   553,
     165,   166,  1058,   167,  1060,   168,  1062,   393,   996,   125,
     997,    82,  1068,   394,    83,   650,   405,   126,   127,   128,
    1039,   474,   475,   476,   477,   478,  1285,   383,   384,  1170,
     511,  1082,   857,  1083,   858,   479,   480,   481,   482,   483,
     484,   485,   486,   592,   593,   487,   404,   651,   499,   509,
     139,   140,  1105,   510,   621,   622,   652,   947,  1174,   412,
     141,   169,   363,   364,  1182,   378,   413,   170,   541,   542,
     543,   544,   799,   800,   151,   142,   808,   809,   379,   380,
    1362,  1175,  1176,  1177,   143,   414,   144,   145,   158,   415,
     159,   160,   161,   162,   163,   164,  1499,  1500,  1501,   810,
     811,   165,   166,   768,   167,  1200,   168,  1205,   950,   951,
     152,   153,   416,  1213,   474,   475,   476,   477,   478,   417,
     307,   953,   954,   171,   172,  1012,   800,  1212,   479,   480,
     481,   482,   483,   484,   485,   486,  1363,  1364,   487,  1431,
    1432,   993,   308,   653,   654,   655,   656,  1292,  1293,  1561,
     146,   154,   155,   156,   157,  1391,   755,   756,   173,   174,
     501,   502,   169,   511,   503,   516,  1138,   232,   170,   474,
     475,   476,   477,   478,   518,   175,   517,  1190,   176,   526,
     529,  1275,   177,   479,   480,   481,   482,   483,   484,   485,
     486,  1365,   531,   487,   532,   533,  1366,   947,  1551,  1552,
    1553,   863,   233,  1208,  1149,   234,   535,   672,   537,   235,
     236,  1235,  1035,   238,   239,    84,   558,   147,   539,   240,
     561,   194,   195,  1272,   171,   172,   562,   673,   674,   749,
     567,   563,  1133,  1134,  1135,  1150,  1136,  1226,  1137,   564,
     568,   675,   676,  1144,   677,   196,  1145,  1222,  1223,  1224,
     241,   573,  1147,   572,   569,   242,   197,  1306,   583,   173,
     174,   418,   419,   420,   421,   585,   576,   584,   587,   586,
     594,   590,  1151,   595,   605,   591,   175,   598,   597,   176,
     608,   604,   606,   177,   158,   511,   159,   160,   161,   162,
     163,   164,   599,   968,   148,   511,   609,   165,   166,   610,
     167,   613,   168,   616,  1392,  1393,  1394,  1266,  1395,   969,
     617,   618,   620,  1267,   626,   131,   132,   135,   136,  1396,
     619,   623,   624,  1270,  1271,   637,  1273,   192,   641,   630,
     642,   643,   647,   644,  1278,   178,  -440,  1279,   645,   648,
    1036,  1037,   179,   657,  1376,  1152,  1153,  1154,  1155,  1156,
    1157,  1158,   658,  1404,   660,   662,   663,   664,   169,   667,
     665,   666,   668,   670,   170,  1159,   671,   680,  1160,   682,
     684,   685,   686,   970,   691,   985,   692,   693,   695,   696,
    1397,  1236,   816,   817,   818,   819,   820,   821,   822,  1430,
     823,   824,   825,   826,   827,   511,   735,  1438,  1245,   736,
     719,   740,  1246,  1247,  1332,  1467,   741,  1469,  1253,   474,
     475,   476,   477,   478,   747,   752,   720,   794,   748,   753,
     171,   172,   754,   479,   480,   481,   482,   483,   484,   485,
     486,   757,   763,   487,   764,   765,   178,  1382,   487,  1382,
     795,   354,   355,   179,   773,   801,  1416,  1316,   796,   805,
    1400,  1401,  1402,   797,   798,   173,   174,   418,   419,   420,
     421,   815,  1505,   839,   842,   840,  1511,  1512,   992,   855,
     860,   861,   175,   865,   866,   176,   867,   721,  1294,   177,
     875,  1144,   722,   723,  1300,   749,  1302,  1038,   872,   876,
     724,   877,   880,   882,  1434,  1436,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   884,   890,   891,  1468,   892,
     893,   895,   903,  1471,  1472,  1473,   904,  1476,   725,   908,
     909,   971,  1554,  1001,   911,   914,   915,   916,   917,   158,
    1562,   159,   160,   161,   162,   163,   164,   920,   923,   924,
     307,   925,   165,   166,   768,   167,   939,   168,  1565,  1356,
    1360,  1361,  1566,  1253,   927,  1568,   726,   928,   929,   952,
     955,   956,  1503,   957,   959,   960,   963,   964,   987,   972,
    1513,  1514,  1515,   965,  1517,  1519,  1416,  1024,  1416,   849,
    1533,   222,   983,   984,   973,   988,   223,  1537,   998,   999,
    1000,  1006,  1007,  1144,  1009,  1014,  1539,  1540,  1015,  1017,
    1020,   224,   974,   169,  1029,  1021,  1032,  1044,   158,   170,
     159,   160,   161,   162,   163,   164,   975,   976,  1434,  1434,
    1434,   165,   166,  1031,   167,  1054,   168,  1045,  1558,  1559,
    1560,  1055,   178,  1047,  1048,   225,  1049,  1050,  1563,   179,
    1564,  1052,  1115,  1053,  1057,   158,  1059,   159,   160,   161,
     162,   163,   164,  1061,  1063,  1064,  1567,  1488,   165,   166,
    1297,   167,  1065,   168,  1066,   171,   172,  1492,  1493,  1494,
    1495,  1067,  1070,   158,  1071,   159,   160,   161,   162,   163,
     164,  1072,   169,  1073,  1074,  1075,   165,   166,   170,   167,
    1076,   168,   474,   475,   476,   477,   478,  1077,  1078,  1079,
     173,   174,  1119,  1080,  1098,  1099,   479,   480,   481,   482,
     483,   484,   485,   486,  1103,  1102,   487,   175,  1104,   169,
     176,  1110,  1111,   226,   177,   170,  1120,   816,   817,   818,
     819,   820,   821,   822,  1123,   823,   824,   825,   826,   827,
    1112,  1126,  1128,  1129,   171,   172,  1130,   169,  1132,  1146,
    1167,  1169,  1184,   170,   474,   475,   476,   477,   478,  1191,
    1185,  1207,  1220,  1013,  1215,  1186,  1168,  1187,   479,   480,
     481,   482,   483,   484,   485,   486,  1188,  1189,   487,   173,
     174,   171,   172,  1227,  1192,  1228,  1570,  1193,  1194,  1195,
     227,  1196,  1197,  1229,  1230,  1243,   175,  1296,  1214,   176,
    1219,  1237,  1239,   177,   474,   475,   476,   477,   478,   171,
     172,  1244,  1238,  1248,  1252,  1257,   173,   174,   479,   480,
     481,   482,   483,   484,   485,   486,  1261,  1274,   487,  1276,
    1277,  1280,  1288,   175,  1289,  1290,   176,  1291,  1299,  1307,
     177,  1311,  1310,  1312,   173,   174,  1315,   228,  1317,  1319,
    1320,  1322,   229,  1340,  1333,   474,   475,   476,   477,   478,
    1345,   175,  1346,  1348,   176,  1349,  1353,   230,   177,   479,
     480,   481,   482,   483,   484,   485,   486,   178,  1368,   487,
    1377,  1407,  1424,  1409,   179,   474,   475,   476,   477,   478,
    1425,  1520,  1521,  1522,  1523,  1524,  1525,  1526,  1527,   479,
     480,   481,   482,   483,   484,   485,   486,  1433,  1474,   487,
     474,   475,   476,   477,   478,  1426,  1427,  1481,  1482,  1428,
    1496,  -441,  -441,  -441,   479,   480,   481,   482,   483,   484,
     485,   486,  1429,  1437,   487,  -441,  -441,  -441,  -441,   483,
     484,   485,   486,  1470,  1480,   487,  1484,  1483,  1489,  1497,
     474,   475,   476,   477,   478,  -435,   178,  1485,  1502,  1498,
    1510,  1504,  1506,   179,   479,   480,   481,   482,   483,   484,
     485,   486,  1516,  1528,   487,  1532,  1534,  1535,  1536,  1538,
    1578,  1571,  1569,  1572,  1573,  1574,  1579,   474,   475,   476,
     477,   478,   804,   178,  1581,  1010,   681,   557,  1509,  1117,
     179,   479,   480,   481,   482,   483,   484,   485,   486,  1118,
    1218,   487,   694,  1173,  1148,   474,   475,   476,   477,   478,
    1256,   178,   831,   961,   718,  1027,  1486,  1004,   179,   479,
     480,   481,   482,   483,   484,   485,   486,  1005,  1544,   487,
     474,   475,   476,   477,   478,   422,  1139,  1546,  1142,  1008,
    1250,  1367,  1131,  1326,   479,   480,   481,   482,   483,   484,
     485,   486,  1116,  1301,   487,   474,   475,   476,   477,   478,
    1379,  1180,  1313,     0,     0,     0,     0,     0,     0,   479,
     480,   481,   482,   483,   484,   485,   486,     0,     0,   487,
       0,     0,     0,     0,     0,   474,   475,   476,   477,   478,
       0,     0,     0,     0,     0,     0,     0,     0,  1231,   479,
     480,   481,   482,   483,   484,   485,   486,     0,     0,   487,
     474,   475,   476,   477,   478,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,     0,   487,   474,   475,   476,   477,   478,
       0,     0,     0,     0,     0,     0,     0,     0,  1232,   479,
     480,   481,   482,   483,   484,   485,   486,     0,     0,   487,
     474,   475,   476,   477,   478,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,     0,   487,     0,   474,   475,   476,   477,
     478,     0,     0,     0,     0,     0,     0,     0,     0,  1233,
     479,   480,   481,   482,   483,   484,   485,   486,     0,     0,
     487,     0,     0,     0,     0,     0,   474,   475,   476,   477,
     478,     0,     0,     0,     0,     0,     0,     0,     0,  1234,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   438,
     487,   474,   475,   476,   477,   478,     0,     0,     0,     0,
       0,     0,     0,     0,  1240,   479,   480,   481,   482,   483,
     484,   485,   486,     0,     0,   487,   474,   475,   476,   477,
     478,     0,     0,     0,     0,     0,  1084,     0,     0,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   438,     0,
     487,     0,     0,     0,  1295,     0,   304,     0,     0,     0,
     232,     0,     0,     0,     0,     0,     0,     0,     0,   474,
     475,   476,   439,   440,     0,   441,   442,     0,     0,     0,
       0,   305,     0,   479,   480,   481,   482,   483,   484,   485,
     486,  1347,  1085,   487,     0,   233,     0,     0,   234,     0,
     443,     0,   235,   236,     0,   306,   238,   239,     0,     0,
       0,     0,   240,     0,   232,     0,     0,     0,     0,  1542,
     307,   439,   440,     0,   441,   442,     0,     0,     0,   232,
       0,   444,     0,     0,   320,     0,     0,     0,     0,     0,
       0,     0,   308,   241,  1547,     0,     0,     0,   242,   233,
       0,     0,   234,     0,     0,     0,   235,   236,     0,     0,
     238,   239,     0,   232,   233,     0,   240,   234,     0,  1548,
       0,   235,   236,     0,     0,   238,   239,     0,  1086,     0,
     444,   240,     0,     0,   445,   446,     0,   447,   448,   449,
     450,   451,   452,   453,     0,     0,     0,   241,   233,  1549,
       0,   234,   242,     0,     0,   235,   236,     0,     0,   238,
     239,     0,   241,     0,     0,   240,   321,   242,     0,     0,
       0,     0,     0,     0,  1550,     0,     0,     0,     0,     0,
       0,  1087,     0,   454,   455,   456,   457,   458,   459,   460,
     461,   462,     0,     0,     0,     0,   241,  1011,     0,     0,
       0,   242,     0,     0,     0,  1088,     0,  1089,   232,   463,
     464,     0,     0,  1090,     0,  1091,     0,     0,     0,  1092,
    1093,     0,  1304,     0,   465,   466,   467,   468,     0,     0,
       0,     0,   454,   455,   456,   457,   458,   459,   460,   461,
     462,     0,     0,   233,     0,     0,   234,     0,  1352,     0,
     235,   236,     0,   237,   238,   239,     0,     0,   463,   464,
     240,  1094,     0,     0,     0,     0,     0,     0,     0,   309,
       0,     0,     0,   465,   466,   467,   468,     0,  1354,   232,
       0,     0,     0,     0,   248,     0,   322,     0,     0,     0,
       0,   241,     0,     0,     0,     0,   242,   469,   470,     0,
       0,     0,     0,  1422,     0,     0,   310,   311,   312,     0,
     249,     0,     0,   287,   233,   313,     0,   234,   288,   289,
     290,   235,   236,   250,     0,   238,   239,     0,  1423,     0,
     314,   240,     0,     0,   220,     0,   251,     0,     0,   252,
       0,   253,     0,   231,   232,  1439,   469,   470,   246,     0,
     247,     0,   286,     0,   298,   291,   303,     0,   319,     0,
       0,   703,   241,     0,     0,     0,   292,   242,   327,   328,
     329,   232,   330,   331,     0,   332,   383,   384,     0,   233,
       0,   254,   234,   255,   323,   307,   235,   236,     0,     0,
     238,   239,   256,     0,     0,     0,   240,   337,     0,   293,
       0,     0,   704,     0,   299,   300,   233,   308,     0,   234,
       0,     0,     0,   235,   236,     0,     0,   238,   239,     0,
    1440,     0,     0,   240,     0,     0,     0,   241,   257,     0,
       0,     0,   242,   301,  1441,     0,     0,     0,   705,   338,
       0,     0,     0,   706,     0,   258,     0,     0,     0,     0,
     707,   708,   259,   260,   241,   261,     0,   262,   263,   242,
     264,   265,   709,   266,     0,     0,   267,   268,     0,   269,
       0,   710,   711,   712,   713,     0,   714,   715,     0,     0,
       0,     0,   270,   271,     0,     0,     0,   272,     0,   273,
     274,  1442,   275,     0,  1443,  1444,     0,   276,     0,     0,
       0,   277,   278,     0,   279,   280,     0,   281,   282,   283,
       0,     0,     0,     0,     0,   474,   475,   476,   477,   478,
       4,     0,     0,     0,     0,     0,     0,     0,   243,   479,
     480,   481,   482,   483,   484,   485,   486,     0,     0,   487,
       0,     0,     5,     6,     0,     0,     0,     0,     0,     0,
       0,  1445,     7,     0,  1446,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1447,     0,  1448,   553,  1449,
    1450,  1451,  1452,  1453,  1454,     0,     0,     8,     0,     0,
    1455,     0,     0,     0,  1456,  1457,     0,     0,  1458,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   284,
       0,  1459,     0,     0,     0,     9,     0,     0,    10,  1460,
      11,     0,     0,     0,     0,     0,     0,    12,     0,    13,
       0,     0,     0,     0,    14,    15,    16,     0,     0,   473,
       0,    17,    18,    19,   474,   475,   476,   477,   478,     0,
       0,     0,     0,     0,     0,  1461,     0,     0,   479,   480,
     481,   482,   483,   484,   485,   486,     0,     0,   487,   474,
     475,   476,   477,   478,   333,     0,     0,     0,     0,     0,
       0,     0,     0,   479,   480,   481,   482,   483,   484,   485,
     486,     0,     0,   487,     0,     0,     0,     0,  1305,     0,
       0,   339,   816,   817,   818,   819,   820,   821,   822,     0,
     823,   824,   825,   826,   827
};

static const yytype_int16 yycheck[] =
{
      17,   287,   149,   150,    81,   179,   179,   148,   107,   627,
     109,   630,   111,   253,   113,   713,   115,   998,   258,   118,
     119,  1021,     7,    18,    19,     6,    15,   260,   261,    22,
      19,    15,    44,   273,    15,    16,    17,    18,    19,    28,
     121,    18,   282,    18,    19,    27,    15,   840,   288,     6,
      19,   291,    30,    26,    27,    29,   219,  1162,    15,    16,
      17,    18,    19,   201,    94,    82,     6,    94,    94,    50,
      15,    16,    17,    18,    19,    15,    16,    17,    18,     3,
       0,    15,    16,    17,    18,    19,    35,    15,   328,    89,
     330,    19,    15,    50,  1163,    44,    19,   235,     8,     9,
      10,    11,    12,   158,  1238,   107,    87,    15,    16,    17,
      18,    19,    22,    23,    24,    25,    26,    27,    28,    29,
      35,   259,    32,     8,     9,    10,    11,    12,    19,    44,
      87,    15,    16,    17,    18,    41,  1359,    22,    23,    24,
      25,    26,    27,    28,    29,     4,    15,    32,   937,    15,
      19,   168,   290,    19,    15,    16,    17,    18,    35,  1356,
     366,   178,  1162,   369,   241,    84,   304,    44,    34,    35,
      36,    37,   310,   311,   321,   252,   138,   139,  1327,   160,
     161,   162,   163,   164,   165,   166,    15,    80,   351,   352,
      19,   729,   115,     3,   732,   813,   734,  1359,   103,   180,
    1305,   120,   183,   160,   161,   162,   163,   164,   165,   166,
     212,   213,   350,  1410,   216,   217,  1350,     3,   124,   125,
     126,   146,   146,   180,   214,   372,   183,   209,    15,   147,
     307,  1380,    19,   374,  1303,   376,   377,    15,   379,   380,
     140,    19,   220,   310,  1244,   164,     8,     9,    10,    11,
      12,   318,   242,   539,   600,    95,    34,    35,    36,    37,
      22,    23,    24,    25,    26,    27,    28,    29,  1491,   269,
      32,     8,     9,    10,    11,    12,   303,   303,   231,   306,
     306,   138,   139,   174,   365,    22,    23,    24,    25,    26,
      27,    28,    29,  1490,   134,    32,     8,     9,    10,    11,
      12,   647,    15,   111,  1409,  1305,    19,   260,   261,   117,
      22,    23,    24,    25,    26,    27,    28,    29,   348,   349,
      32,    34,    35,    36,    37,  1114,   231,   567,   115,  1491,
     292,   121,  1030,   573,   252,   575,   121,   237,    19,    20,
     395,   234,   397,   576,   399,   400,   315,   316,   214,   215,
     590,   121,   364,    44,   200,   595,  1356,   597,   364,   599,
     366,   601,   287,   365,   604,   605,   606,  1348,   361,    19,
     365,    19,   361,   613,  1167,   513,   616,   362,   367,   517,
     361,   398,    77,   367,   365,   310,   232,   404,   365,   363,
     365,   364,   361,    18,    19,   412,   413,   414,   415,   416,
      50,    19,    93,    94,   361,   645,    19,    98,   365,  1409,
    1410,   428,   103,   551,    19,   364,   361,   650,   556,   652,
     558,   361,   662,   663,    15,   365,   503,   361,    19,    84,
     111,    44,   360,   361,   572,   292,   669,    87,   361,   977,
     365,   979,    80,   581,    35,   583,    19,   585,   123,   364,
     588,   589,   362,   361,   360,    19,   366,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     364,    44,  1170,    22,   331,    18,    19,   361,    19,    20,
     713,   366,   362,    32,  1103,   502,   366,   364,   626,    19,
    1490,   360,   361,   366,   511,   361,   369,    20,    20,   637,
     361,  1482,   215,    44,    19,   738,    19,    20,     3,   287,
     160,   161,   162,   163,   164,   165,   166,  1219,   143,   210,
     658,     3,   660,     8,     9,    10,    11,    12,    66,   667,
     180,    44,   361,   183,    57,    58,   553,    22,    23,    24,
      25,    26,    27,    28,    29,   287,   288,    32,     8,     9,
      10,    11,    12,     3,     3,   702,    15,    15,    17,    18,
    1178,    19,    22,    23,    24,    25,    26,    27,    28,    29,
     240,   241,    32,    44,   361,    90,    34,    35,    36,    37,
    1198,   323,    15,   361,    17,    18,  1288,  1289,  1290,  1291,
     731,    80,   733,     8,     9,    10,    11,    12,     3,   737,
     773,   774,     3,   836,   366,   779,   892,    22,    23,    24,
      25,    26,    27,    28,    29,   855,   215,    32,   131,   132,
      28,    29,    93,    94,    32,   865,     3,    98,    33,   366,
      42,    80,   872,   363,     3,   234,   366,    42,     3,   154,
      45,     8,     9,    10,    11,    12,   222,   106,   361,    61,
     106,    56,   108,   295,   366,    22,    23,    24,    25,    26,
      27,    28,    29,    19,   395,    32,   397,   116,   399,   400,
       3,    76,   271,    85,   125,    80,     3,   128,    83,    15,
      85,    86,   131,    19,   970,   106,   972,   108,    93,    15,
     976,     3,   165,    19,   143,   833,   843,    29,    34,    35,
      36,    37,   344,   345,   346,   347,   939,     3,    34,    35,
      36,    37,    19,    20,    20,   365,   121,   122,    18,    19,
      20,     3,   860,   861,   862,    19,    20,    13,   133,    15,
      16,    17,    18,    19,    20,   147,    72,    44,   337,   210,
      26,    27,   880,    29,   882,    31,   884,     3,   765,    55,
     767,   156,   890,     3,   159,   228,   209,    63,    64,    65,
     859,     8,     9,    10,    11,    12,   365,    18,    19,    20,
     361,   909,   556,   911,   558,    22,    23,    24,    25,    26,
      27,    28,    29,   250,   251,    32,   361,   260,    15,    15,
     111,   112,   930,    19,   338,   339,   269,  1030,    77,   361,
     121,    87,    19,    20,  1037,   320,   361,    93,    34,    35,
      36,    37,   365,   366,    75,   136,    59,    60,   333,   334,
      93,   100,   101,   102,   145,   361,   147,   148,    13,   361,
      15,    16,    17,    18,    19,    20,    38,    39,    40,    59,
      60,    26,    27,    28,    29,  1085,    31,  1087,   365,   366,
     111,   112,   361,  1093,     8,     9,    10,    11,    12,   361,
     105,   365,   366,   149,   150,   365,   366,   325,    22,    23,
      24,    25,    26,    27,    28,    29,   149,   150,    32,   214,
     215,   366,   127,   356,   357,   358,   359,  1229,  1230,   215,
     211,   152,   153,   154,   155,   140,   408,   409,   184,   185,
       3,    22,    87,   361,    62,   360,   366,    45,    93,     8,
       9,    10,    11,    12,   129,   201,   140,  1055,   204,    19,
     360,  1207,   208,    22,    23,    24,    25,    26,    27,    28,
      29,   204,   106,    32,   364,   364,   209,  1170,  1496,  1497,
    1498,   277,    80,  1090,    19,    83,   364,    75,    19,    87,
      88,   366,    90,    91,    92,   360,    98,   278,    84,    97,
     360,    19,    20,  1203,   149,   150,   360,    95,    96,   986,
      77,   364,   989,   990,   991,    50,   993,  1115,   995,   364,
     360,   109,   110,  1000,   112,    43,  1003,  1107,  1108,  1109,
     128,   276,  1009,    98,   238,   133,    54,   364,    72,   184,
     185,   186,   187,   188,   189,    72,   126,   225,   230,   223,
     250,   234,    87,   254,   272,   236,   201,   259,   257,   204,
     221,   234,   270,   208,    13,   361,    15,    16,    17,    18,
      19,    20,   264,     3,   355,   361,   360,    26,    27,   364,
      29,    83,    31,   319,   289,   290,   291,  1185,   293,    19,
     360,   364,    80,  1191,    72,     7,     8,     9,    10,   304,
     364,   360,   364,  1201,  1202,    72,  1204,    19,   360,   364,
     360,   364,    80,   364,  1212,   361,   362,  1215,   312,   360,
     218,   219,   368,   360,  1317,   160,   161,   162,   163,   164,
     165,   166,    80,  1333,    72,    75,    77,   360,    87,    72,
     360,   360,    20,   360,    93,   180,   360,     3,   183,     3,
       3,     3,     3,    83,     3,   362,    19,     3,     3,     3,
     365,  1138,   167,   168,   169,   170,   171,   172,   173,  1369,
     175,   176,   177,   178,   179,   361,     3,  1377,  1155,     3,
       3,   141,  1159,  1160,  1282,  1385,   141,  1387,  1165,     8,
       9,    10,    11,    12,    14,    26,    19,   169,    15,   209,
     149,   150,    27,    22,    23,    24,    25,    26,    27,    28,
      29,    29,    19,    32,    15,   366,   361,  1324,    32,  1326,
     192,   133,   134,   368,     7,     3,  1359,  1264,   200,   360,
    1328,  1329,  1330,   205,   206,   184,   185,   186,   187,   188,
     189,   360,  1442,   360,    19,   361,  1446,  1447,   362,   104,
      72,    72,   201,    50,   360,   204,   360,    80,  1235,   208,
     360,  1238,    85,    86,  1241,  1242,  1243,   365,   262,   360,
      93,    30,   143,    72,  1372,  1373,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    72,    72,   360,  1386,    84,
     360,   360,   360,  1391,  1392,  1393,   360,  1395,   121,   360,
     143,   231,  1502,   362,    98,    19,   360,   360,   360,    13,
    1510,    15,    16,    17,    18,    19,    20,   360,   360,   360,
     105,   360,    26,    27,    28,    29,   228,    31,  1528,   364,
    1307,  1308,  1532,  1310,   360,  1535,   159,   360,   360,     3,
       3,    19,  1440,    15,    19,    19,    19,     3,   362,   279,
    1448,  1449,  1450,    20,  1452,  1453,  1489,   362,  1491,    19,
    1458,    69,    15,    15,   294,    27,    74,  1465,     7,   366,
     366,    15,    18,  1350,   361,    20,  1474,  1475,   360,   360,
     360,    89,   312,    87,    27,   364,    99,   360,    13,    93,
      15,    16,    17,    18,    19,    20,   326,   327,  1496,  1497,
    1498,    26,    27,   366,    29,    19,    31,   360,  1506,  1507,
    1508,    41,   361,   360,   360,   123,   360,   360,  1516,   368,
    1518,   360,   322,   360,   360,    13,   360,    15,    16,    17,
      18,    19,    20,   360,   360,   360,  1534,  1414,    26,    27,
      28,    29,   360,    31,   360,   149,   150,  1424,  1425,  1426,
    1427,   360,   360,    13,   360,    15,    16,    17,    18,    19,
      20,   360,    87,   360,   360,   360,    26,    27,    93,    29,
     360,    31,     8,     9,    10,    11,    12,   360,   360,   360,
     184,   185,     3,   360,   360,   360,    22,    23,    24,    25,
      26,    27,    28,    29,   360,   365,    32,   201,   360,    87,
     204,   365,   360,   211,   208,    93,     3,   167,   168,   169,
     170,   171,   172,   173,    15,   175,   176,   177,   178,   179,
     360,     3,     3,   143,   149,   150,   143,    87,    27,   366,
     360,   141,   360,    93,     8,     9,    10,    11,    12,   143,
     366,   312,    20,   362,   328,   360,   362,   360,    22,    23,
      24,    25,    26,    27,    28,    29,   360,   360,    32,   184,
     185,   149,   150,     3,   360,     3,  1543,   360,   360,   360,
     278,   360,   360,    15,    15,    22,   201,     7,   360,   204,
     360,   362,    15,   208,     8,     9,    10,    11,    12,   149,
     150,   361,   366,   365,   360,    15,   184,   185,    22,    23,
      24,    25,    26,    27,    28,    29,   364,   364,    32,   364,
     364,   364,   360,   201,   360,   360,   204,   360,   365,    22,
     208,   360,   366,   143,   184,   185,    19,   335,   221,   360,
     360,   364,   340,   360,   272,     8,     9,    10,    11,    12,
       3,   201,     3,   361,   204,   362,   362,   355,   208,    22,
      23,    24,    25,    26,    27,    28,    29,   361,    15,    32,
     218,   362,   361,   182,   368,     8,     9,    10,    11,    12,
     361,   295,   296,   297,   298,   299,   300,   301,   302,    22,
      23,    24,    25,    26,    27,    28,    29,   215,   236,    32,
       8,     9,    10,    11,    12,   361,   361,   313,   366,   360,
     216,     8,     9,    10,    22,    23,    24,    25,    26,    27,
      28,    29,   360,   360,    32,    22,    23,    24,    25,    26,
      27,    28,    29,   360,   360,    32,   360,   362,     7,   216,
       8,     9,    10,    11,    12,   360,   361,   365,   312,   216,
     272,   364,   314,   368,    22,    23,    24,    25,    26,    27,
      28,    29,   236,   330,    32,   297,   322,   295,   360,   360,
     313,   360,   362,   360,   360,   360,   307,     8,     9,    10,
      11,    12,   506,   361,   360,   800,   346,   239,  1444,   951,
     368,    22,    23,    24,    25,    26,    27,    28,    29,   954,
    1103,    32,   365,  1031,  1020,     8,     9,    10,    11,    12,
    1167,   361,   525,   708,   372,   841,  1409,   773,   368,    22,
      23,    24,    25,    26,    27,    28,    29,   774,  1489,    32,
       8,     9,    10,    11,    12,   178,   362,  1491,   999,   779,
    1163,  1310,   986,  1277,    22,    23,    24,    25,    26,    27,
      28,    29,   941,  1242,    32,     8,     9,    10,    11,    12,
    1321,  1036,  1260,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
      -1,    -1,    -1,    -1,    -1,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   362,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   362,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,    -1,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   362,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,    -1,    -1,    -1,    -1,    -1,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   362,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,     5,
      32,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   362,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,     5,    -1,
      32,    -1,    -1,    -1,   362,    -1,    41,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
       9,    10,    78,    79,    -1,    81,    82,    -1,    -1,    -1,
      -1,    66,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,   362,   146,    32,    -1,    80,    -1,    -1,    83,    -1,
     106,    -1,    87,    88,    -1,    90,    91,    92,    -1,    -1,
      -1,    -1,    97,    -1,    45,    -1,    -1,    -1,    -1,   362,
     105,    78,    79,    -1,    81,    82,    -1,    -1,    -1,    45,
      -1,   137,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   127,   128,   362,    -1,    -1,    -1,   133,    80,
      -1,    -1,    83,    -1,    -1,    -1,    87,    88,    -1,    -1,
      91,    92,    -1,    45,    80,    -1,    97,    83,    -1,   362,
      -1,    87,    88,    -1,    -1,    91,    92,    -1,   232,    -1,
     137,    97,    -1,    -1,   190,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,    -1,    -1,    -1,   128,    80,   362,
      -1,    83,   133,    -1,    -1,    87,    88,    -1,    -1,    91,
      92,    -1,   128,    -1,    -1,    97,   147,   133,    -1,    -1,
      -1,    -1,    -1,    -1,   362,    -1,    -1,    -1,    -1,    -1,
      -1,   285,    -1,   239,   240,   241,   242,   243,   244,   245,
     246,   247,    -1,    -1,    -1,    -1,   128,   360,    -1,    -1,
      -1,   133,    -1,    -1,    -1,   309,    -1,   311,    45,   265,
     266,    -1,    -1,   317,    -1,   319,    -1,    -1,    -1,   323,
     324,    -1,   360,    -1,   280,   281,   282,   283,    -1,    -1,
      -1,    -1,   239,   240,   241,   242,   243,   244,   245,   246,
     247,    -1,    -1,    80,    -1,    -1,    83,    -1,   360,    -1,
      87,    88,    -1,    90,    91,    92,    -1,    -1,   265,   266,
      97,   365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,
      -1,    -1,    -1,   280,   281,   282,   283,    -1,   360,    45,
      -1,    -1,    -1,    -1,    50,    -1,   267,    -1,    -1,    -1,
      -1,   128,    -1,    -1,    -1,    -1,   133,   353,   354,    -1,
      -1,    -1,    -1,   360,    -1,    -1,   341,   342,   343,    -1,
      76,    -1,    -1,   279,    80,   350,    -1,    83,   284,   285,
     286,    87,    88,    89,    -1,    91,    92,    -1,   360,    -1,
     365,    97,    -1,    -1,    90,    -1,   102,    -1,    -1,   105,
      -1,   107,    -1,    99,    45,    65,   353,   354,   104,    -1,
     106,    -1,   108,    -1,   110,   321,   112,    -1,   114,    -1,
      -1,     3,   128,    -1,    -1,    -1,   332,   133,    69,    70,
      71,    45,    73,    74,    -1,    76,    18,    19,    -1,    80,
      -1,   147,    83,   149,   365,   105,    87,    88,    -1,    -1,
      91,    92,   158,    -1,    -1,    -1,    97,    71,    -1,   365,
      -1,    -1,    44,    -1,   336,   337,    80,   127,    -1,    83,
      -1,    -1,    -1,    87,    88,    -1,    -1,    91,    92,    -1,
     140,    -1,    -1,    97,    -1,    -1,    -1,   128,   194,    -1,
      -1,    -1,   133,   365,   154,    -1,    -1,    -1,    80,   113,
      -1,    -1,    -1,    85,    -1,   211,    -1,    -1,    -1,    -1,
      92,    93,   218,   219,   128,   221,    -1,   223,   224,   133,
     226,   227,   104,   229,    -1,    -1,   232,   233,    -1,   235,
      -1,   113,   114,   115,   116,    -1,   118,   119,    -1,    -1,
      -1,    -1,   248,   249,    -1,    -1,    -1,   253,    -1,   255,
     256,   211,   258,    -1,   214,   215,    -1,   263,    -1,    -1,
      -1,   267,   268,    -1,   270,   271,    -1,   273,   274,   275,
      -1,    -1,    -1,    -1,    -1,     8,     9,    10,    11,    12,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   365,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
      -1,    -1,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   271,    77,    -1,   274,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   285,    -1,   287,   210,   289,
     290,   291,   292,   293,   294,    -1,    -1,   102,    -1,    -1,
     300,    -1,    -1,    -1,   304,   305,    -1,    -1,   308,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   365,
      -1,   321,    -1,    -1,    -1,   130,    -1,    -1,   133,   329,
     135,    -1,    -1,    -1,    -1,    -1,    -1,   142,    -1,   144,
      -1,    -1,    -1,    -1,   149,   150,   151,    -1,    -1,     3,
      -1,   156,   157,   158,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,   365,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,     8,
       9,    10,    11,    12,   365,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,    -1,    -1,    -1,    -1,   181,    -1,
      -1,   365,   167,   168,   169,   170,   171,   172,   173,    -1,
     175,   176,   177,   178,   179
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   371,   372,    45,    67,    68,    77,   102,   130,
     133,   135,   142,   144,   149,   150,   151,   156,   157,   158,
     396,   397,   398,   399,   400,   401,   452,   453,   454,   455,
     457,   458,   459,   462,   465,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   558,   594,   595,   596,
     597,   598,   599,   600,   601,   620,   622,     0,     3,    33,
      42,    45,    56,    76,    80,    83,    85,    86,    93,   121,
     122,   133,   156,   159,   360,   373,   386,   392,   395,   404,
     406,   409,   411,   414,   416,   417,   419,   420,   427,   437,
     438,   493,   495,   505,   544,   547,   559,   560,   561,   562,
     603,   604,   605,   606,   614,   615,   621,   623,   624,   625,
      19,    20,    44,   491,    20,    55,    63,    64,    65,   402,
       3,   491,   491,   131,   132,   491,   491,     3,   121,   111,
     112,   121,   136,   145,   147,   148,   211,   278,   355,   121,
     121,    75,   111,   112,   152,   153,   154,   155,    13,    15,
      16,    17,    18,    19,    20,    26,    27,    29,    31,    87,
      93,   149,   150,   184,   185,   201,   204,   208,   361,   368,
     510,   523,   528,   531,   532,   533,   535,   537,    35,    44,
     364,   480,   491,    19,    19,    20,    43,    54,   384,   388,
     111,   117,    42,    61,    85,   147,   393,   394,    77,    19,
      84,    19,    80,   123,   111,   384,   537,    19,    19,   421,
     421,   364,    69,    74,    89,   123,   211,   278,   335,   340,
     355,   421,    45,    80,    83,    87,    88,    90,    91,    92,
      97,   128,   133,   365,   422,   440,   421,   421,    50,    76,
      89,   102,   105,   107,   147,   149,   158,   194,   211,   218,
     219,   221,   223,   224,   226,   227,   229,   232,   233,   235,
     248,   249,   253,   255,   256,   258,   263,   267,   268,   270,
     271,   273,   274,   275,   365,   422,   421,   279,   284,   285,
     286,   321,   332,   365,   422,   563,   564,   565,   421,   336,
     337,   365,   422,   421,    41,    66,    90,   105,   127,   304,
     341,   342,   343,   350,   365,   422,   447,   449,   450,   421,
      65,   147,   267,   365,   422,   616,   619,    69,    70,    71,
      73,    74,    76,   365,   405,   408,   422,    71,   113,   365,
     407,   422,    35,    44,   364,   441,   402,     3,     3,   402,
      66,   403,     3,     3,   491,   491,     3,    35,    44,   364,
     444,    80,   467,    19,    20,    44,   492,     3,   146,   463,
       3,     3,   460,   466,   222,    19,    90,   154,   320,   333,
     334,   456,   456,    18,    19,   377,   380,   380,     3,     3,
       3,     3,     3,     3,     3,    15,    19,    28,   361,   367,
     527,   529,   535,    29,   361,   209,    27,   209,    15,   367,
     530,   537,   361,   361,   361,   361,   361,   361,   186,   187,
     188,   189,   517,   537,    15,    16,    17,    19,   361,   510,
     511,   515,   518,   519,   521,   523,   524,   525,     5,    78,
      79,    81,    82,   106,   137,   190,   191,   193,   194,   195,
     196,   197,   198,   199,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   265,   266,   280,   281,   282,   283,   353,
     354,   536,   626,     3,     8,     9,    10,    11,    12,    22,
      23,    24,    25,    26,    27,    28,    29,    32,    45,    46,
      47,    48,    49,    50,    51,    52,    53,   390,   391,    15,
     481,     3,    22,    62,   387,    44,   364,   389,   441,    15,
      19,   361,   374,    20,    57,    58,   360,   140,   129,   415,
      15,    17,    18,   106,   410,   494,    19,   412,   444,   360,
     506,   106,   364,   364,   418,   364,   441,    19,   426,    84,
     374,    34,    35,    36,    37,   374,   376,   439,    44,    93,
      94,    98,   103,   210,   423,   502,    98,   423,    98,   384,
     444,   360,   360,   364,   364,   140,   237,    77,   360,   238,
     384,   376,    98,   276,   147,   252,   126,   376,   360,   374,
     377,   143,   377,    72,   225,    72,   223,   230,   240,   241,
     234,   236,   250,   251,   250,   254,   376,   257,   259,   264,
      80,   234,    89,   269,   234,   272,   270,   376,   221,   360,
     364,   410,   376,    83,   374,   376,   319,   360,   364,   364,
      80,   338,   339,   360,   364,   374,    72,   612,   613,   384,
     364,    94,   348,   349,   607,   374,   374,    72,   219,   351,
     352,   360,   360,   364,   364,   312,   380,    80,   360,   165,
     228,   260,   269,   356,   357,   358,   359,   360,    80,   376,
      72,   376,    75,    77,   360,   360,   360,    72,    20,   385,
     360,   360,    75,    95,    96,   109,   110,   112,   442,   443,
       3,   403,     3,   374,     3,     3,     3,    95,   134,   445,
     446,     3,    19,     3,   492,     3,     3,     3,    80,   116,
     131,   143,   464,     3,    44,    80,    85,    92,    93,   104,
     113,   114,   115,   116,   118,   119,   380,   461,   502,     3,
      19,    80,    85,    86,    93,   121,   159,   456,   456,   456,
     602,    44,   456,    44,   456,     3,     3,    29,   363,   382,
     141,   141,   529,   529,   537,   529,   529,    14,    15,   537,
     541,   542,    26,   209,    27,   530,   530,    29,   537,   537,
     537,   537,   537,    19,    15,   366,   362,   366,    28,   513,
     514,   517,   537,     7,   366,   369,    26,    27,   364,   366,
     369,   537,   537,   537,   537,   537,   537,   537,   537,   537,
     537,   537,   537,   537,   169,   192,   200,   205,   206,   365,
     366,     3,   537,   384,   390,   360,   537,   374,    59,    60,
      59,    60,   374,   434,   435,   360,   167,   168,   169,   170,
     171,   172,   173,   175,   176,   177,   178,   179,   496,   497,
     498,   500,   504,    41,   124,   125,   126,   360,   413,   360,
     361,   503,    19,   121,   365,   410,   428,   431,   432,    19,
     500,   501,    35,   374,   425,   104,   537,   425,   425,   546,
      72,    72,    72,   277,   376,    50,   360,   360,   374,   214,
     215,   376,   262,   376,   377,   360,   360,    30,   378,   374,
     143,   374,    72,   374,    72,   103,   231,   374,   374,   376,
      72,   360,    84,   360,   376,   360,   376,   231,   260,   261,
     376,   426,   376,   360,   360,   376,   376,   376,   360,   143,
     376,    98,   376,   566,    19,   360,   360,   360,   374,   432,
     360,   448,   449,   360,   360,   360,   374,   360,   360,   360,
      84,   120,   164,   451,   376,   426,    20,   377,   377,   228,
     617,   618,   374,   374,   376,   376,   374,   377,   380,   381,
     365,   366,     3,   365,   366,     3,    19,    15,   380,    19,
      19,   501,   381,    19,     3,    20,   593,   593,     3,    19,
      83,   231,   279,   294,   312,   326,   327,   456,   593,   456,
     593,   374,   377,    15,    15,   362,   366,   362,    27,   366,
     366,   366,   362,   366,   362,   366,   537,   537,     7,   366,
     366,   362,    18,   361,   511,   519,    15,    18,   524,   361,
     391,   360,   365,   362,    20,   360,   432,   360,    19,   174,
     360,   364,   374,   377,   362,   497,   499,   504,   380,    27,
     430,   366,    99,   424,   376,    90,   218,   219,   365,   422,
     545,   374,   374,   374,   360,   360,   376,   360,   360,   360,
     360,   376,   360,   360,    19,    41,   379,   360,   374,   360,
     374,   360,   374,   360,   360,   360,   360,   360,   374,   410,
     360,   360,   360,   360,   360,   360,   360,   360,   360,   360,
     360,   360,   374,   374,    90,   146,   232,   285,   309,   311,
     317,   319,   323,   324,   365,   567,   574,   577,   360,   360,
     364,   611,   365,   360,   360,   374,   106,   108,   106,   108,
     365,   360,   360,   378,   377,   322,   617,   443,   446,     3,
       3,   410,   410,    15,   410,   593,     3,   593,     3,   143,
     143,   541,    27,   537,   537,   537,   537,   537,   366,   362,
     513,   537,   514,   516,   537,   537,   366,   537,   498,    19,
      50,    87,   160,   161,   162,   163,   164,   165,   166,   180,
     183,   507,   508,   533,   534,   538,   543,   360,   362,   141,
      20,   381,   429,   431,    77,   100,   101,   102,   548,   552,
     548,   553,   377,   557,   360,   366,   360,   360,   360,   360,
     374,   143,   360,   360,   360,   360,   360,   360,   586,   592,
     376,   287,   288,   323,   287,   376,   568,   312,   380,   570,
     571,   569,   325,   376,   360,   328,   587,   610,   448,   360,
      20,   383,   383,   383,   383,   378,   374,     3,     3,    15,
      15,   362,   362,   362,   362,   366,   537,   362,   366,    15,
     362,    22,   361,    22,   361,   537,   537,   537,   365,   543,
     536,   626,   360,   537,   539,   540,   499,    15,   381,   432,
     433,   364,   551,    30,   220,   554,   374,   374,   432,   588,
     374,   374,   376,   374,   364,   410,   364,   364,   374,   374,
     364,   215,   234,   271,   337,   365,   609,   451,   360,   360,
     360,   360,   467,   467,   537,   362,     7,    28,   516,   365,
     537,   542,   537,   533,   360,   181,   364,    22,    22,    32,
     366,   360,   143,   551,   550,    19,   384,   221,   555,   360,
     360,   589,   364,   591,   579,   572,   579,   575,   138,   139,
     292,   436,   374,   272,   295,   344,   345,   346,   347,   608,
     360,   451,   451,   451,   451,     3,     3,   362,   361,   362,
       7,   362,   360,   362,   360,   626,   364,   509,   543,   526,
     537,   537,    93,   149,   150,   204,   209,   540,    15,   107,
     212,   213,   216,   217,   365,   549,   377,   218,   556,   587,
     590,   365,   380,   580,   581,   146,   287,   310,   365,   573,
     365,   140,   289,   290,   291,   293,   304,   365,   447,   576,
     374,   374,   374,   215,   376,   513,   516,   362,   507,   182,
       6,    15,    16,    17,   361,   365,   510,   512,   515,   518,
     520,   522,   360,   360,   361,   361,   361,   361,   360,   360,
     376,   214,   215,   215,   374,   375,   374,   360,   376,    65,
     140,   154,   211,   214,   215,   271,   274,   285,   287,   289,
     290,   291,   292,   293,   294,   300,   304,   305,   308,   321,
     329,   365,   447,   578,   310,   318,   582,   376,   374,   376,
     360,   374,   374,   374,   236,   115,   374,    94,   303,   306,
     360,   313,   366,   362,   360,   365,   509,   507,   537,     7,
     363,   366,   537,   537,   537,   537,   216,   216,   216,    38,
      39,    40,   312,   374,   364,   376,   314,   292,   331,   436,
     272,   376,   376,   374,   374,   374,   236,   374,   115,   374,
     295,   296,   297,   298,   299,   300,   301,   302,   330,    94,
     303,   306,   297,   374,   322,   295,   360,   374,   360,   374,
     374,   513,   362,   361,   512,   507,   520,   362,   362,   362,
     362,   375,   375,   375,   376,   583,   315,   316,   374,   374,
     374,   215,   376,   374,   374,   376,   376,   374,   376,   362,
     537,   360,   360,   360,   360,    18,   365,   585,   313,   307,
     584,   360
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   370,   371,   371,   372,   372,   373,   374,   374,   374,
     375,   375,   375,   376,   376,   376,   376,   376,   376,   377,
     377,   378,   378,   379,   379,   380,   381,   381,   382,   382,
     383,   384,   384,   385,   385,   386,   387,   387,   388,   388,
     388,   389,   389,   390,   390,   391,   391,   391,   391,   391,
     391,   391,   391,   391,   392,   392,   393,   393,   393,   393,
     394,   394,   394,   394,   394,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   402,   403,   403,   403,   404,   405,
     405,   405,   405,   405,   406,   407,   407,   408,   409,   409,
     410,   410,   410,   411,   412,   412,   413,   413,   413,   413,
     414,   415,   415,   416,   417,   418,   418,   419,   419,   420,
     420,   421,   421,   421,   422,   422,   422,   422,   422,   422,
     422,   422,   422,   422,   422,   422,   422,   422,   423,   423,
     423,   423,   424,   424,   424,   424,   424,   425,   425,   426,
     427,   427,   428,   429,   429,   429,   430,   430,   431,   432,
     432,   433,   434,   435,   436,   436,   437,   438,   438,   438,
     439,   440,   441,   441,   441,   442,   442,   443,   443,   443,
     443,   443,   443,   444,   444,   444,   445,   445,   446,   446,
     447,   447,   448,   448,   449,   449,   450,   451,   451,   451,
     451,   451,   451,   452,   453,   454,   455,   456,   456,   457,
     458,   459,   460,   460,   460,   460,   460,   460,   460,   460,
     460,   460,   460,   460,   460,   461,   461,   461,   462,   463,
     463,   463,   463,   464,   464,   464,   465,   466,   466,   466,
     466,   466,   466,   466,   466,   467,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     480,   480,   481,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   491,   491,   492,   492,   492,   494,
     493,   495,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   497,   498,   498,   499,   499,
     500,   501,   501,   502,   503,   503,   504,   506,   505,   507,
     507,   508,   508,   509,   509,   510,   511,   511,   511,   511,
     511,   511,   512,   512,   512,   512,   512,   513,   514,   514,
     514,   515,   515,   516,   517,   517,   517,   517,   518,   518,
     518,   519,   519,   519,   519,   520,   520,   520,   520,   521,
     521,   522,   522,   523,   524,   524,   524,   524,   525,   525,
     526,   526,   526,   527,   527,   528,   528,   529,   529,   529,
     529,   529,   530,   530,   530,   531,   531,   531,   531,   531,
     531,   531,   531,   531,   531,   531,   532,   532,   533,   534,
     535,   536,   536,   536,   536,   536,   536,   536,   536,   536,
     536,   537,   537,   537,   537,   537,   537,   537,   537,   537,
     537,   537,   537,   537,   537,   537,   537,   537,   537,   537,
     537,   537,   537,   537,   537,   537,   537,   537,   537,   537,
     537,   537,   537,   537,   537,   537,   537,   537,   538,   538,
     538,   538,   538,   538,   539,   540,   540,   540,   541,   541,
     542,   542,   543,   543,   543,   543,   543,   543,   543,   543,
     543,   543,   543,   543,   543,   543,   543,   543,   544,   545,
     545,   545,   545,   546,   546,   547,   548,   549,   549,   549,
     549,   549,   549,   550,   550,   551,   551,   552,   553,   554,
     554,   554,   555,   555,   556,   556,   557,   558,   559,   560,
     560,   560,   560,   560,   560,   560,   560,   560,   560,   560,
     560,   560,   560,   560,   560,   560,   560,   560,   560,   560,
     560,   560,   560,   560,   560,   560,   560,   560,   560,   560,
     560,   560,   560,   560,   560,   560,   560,   560,   560,   560,
     560,   560,   560,   560,   560,   560,   560,   560,   560,   560,
     560,   560,   560,   561,   562,   562,   563,   563,   563,   563,
     563,   563,   563,   563,   564,   565,   566,   566,   567,   567,
     567,   567,   567,   567,   567,   567,   567,   568,   567,   569,
     567,   567,   567,   567,   570,   570,   571,   572,   572,   573,
     573,   573,   574,   574,   575,   575,   576,   576,   576,   576,
     576,   576,   576,   576,   576,   576,   576,   577,   578,   578,
     578,   578,   578,   578,   578,   578,   578,   578,   578,   578,
     578,   578,   578,   578,   578,   578,   578,   578,   578,   578,
     578,   578,   578,   578,   578,   578,   578,   578,   578,   578,
     578,   578,   578,   578,   578,   578,   579,   579,   580,   581,
     582,   582,   582,   583,   583,   584,   584,   585,   586,   587,
     587,   589,   588,   590,   590,   591,   591,   592,   593,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   602,
     602,   602,   602,   602,   602,   602,   602,   603,   604,   604,
     604,   604,   604,   605,   606,   606,   606,   606,   606,   606,
     606,   606,   606,   606,   606,   606,   606,   607,   607,   607,
     608,   608,   608,   608,   608,   609,   609,   609,   609,   609,
     609,   609,   610,   610,   611,   611,   612,   613,   614,   615,
     615,   615,   615,   615,   616,   617,   617,   618,   618,   619,
     619,   619,   619,   619,   619,   619,   619,   619,   620,   621,
     621,   621,   621,   621,   621,   621,   621,   621,   621,   621,
     621,   621,   621,   621,   622,   622,   622,   622,   622,   622,
     622,   622,   622,   622,   622,   622,   622,   622,   622,   622,
     622,   622,   622,   622,   622,   622,   622,   622,   622,   622,
     622,   622,   622,   622,   622,   622,   622,   622,   622,   622,
     622,   622,   622,   622,   622,   622,   622,   622,   622,   622,
     623,   623,   623,   623,   623,   623,   623,   623,   623,   624,
     624,   624,   624,   625,   625,   625,   626,   626,   626,   626,
     626,   626,   626,   626,   626,   626,   626,   626,   626,   626,
     626,   626,   626,   626,   626,   626,   626,   626,   626
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     0,     2,     2,     1,     1,     2,     2,
       1,     1,     1,     1,     0,     4,     2,     0,     1,     2,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     3,     1,     1,     1,     1,
       2,     4,     3,     3,     3,     3,     3,     4,     5,     3,
       3,     4,     2,     0,     1,     0,     1,     2,     2,     2,
       3,     2,     3,     3,     2,     3,     3,     3,     4,     5,
       1,     1,     1,     4,     0,     2,     2,     2,     1,     1,
       5,     0,     1,     3,     3,     0,     8,     1,     4,     1,
       1,     0,     1,     3,     0,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     4,     2,     3,     2,     2,     1,
       1,     1,     0,     2,     2,     2,     2,     2,     1,     1,
       3,     3,     0,     1,     1,     2,     0,     1,     3,     1,
       3,     1,     0,     2,     2,     2,     2,     3,     3,     3,
       0,     3,     1,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     3,     1,     1,
       4,     1,     0,     3,     4,     1,     2,     0,     5,     5,
       5,     5,     4,     3,     3,     4,     5,     1,     0,     3,
       4,     4,     0,     2,     3,     3,     3,     2,     2,     2,
       2,     3,     3,     2,     2,     1,     1,     1,     4,     0,
       3,     3,     3,     0,     1,     1,     4,     0,     2,     2,
       2,     2,     2,     2,     2,     0,     2,     9,     9,     4,
       3,     3,     3,     3,     3,     3,     3,     3,     4,     1,
       1,     3,     0,     1,     3,     3,     3,     3,     4,     4,
       4,     4,     2,     1,     1,     1,     1,     0,     1,     0,
       4,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     0,     3,     1,     3,
       1,     1,     1,     2,     3,     2,     4,     0,     5,     0,
       1,     1,     2,     1,     3,     1,     1,     1,     1,     1,
       3,     1,     1,     3,     1,     1,     1,     1,     1,     3,
       1,     5,    11,     1,     1,     1,     2,     1,     7,     9,
       7,     1,     1,     1,     3,     1,     1,     1,     3,     1,
       3,     1,     3,     3,     1,     2,     2,     6,     1,     3,
       0,     4,     3,     1,     3,     3,     3,     2,     2,     2,
       2,     0,     2,     2,     0,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     1,     1,     5,     7,     0,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     4,     1,     1,     1,
       1,     2,     2,     3,     3,     6,     3,     3,     3,     3,
       5,     6,     6,     6,     6,     4,     8,     4,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     3,     1,     3,
       0,     1,     4,     6,     4,     3,     5,     5,     4,     6,
       3,     2,     5,     5,     8,     8,     8,     8,     2,     1,
       2,     2,     2,     0,     3,     5,     0,     2,     4,     4,
       4,     2,     2,     0,     3,     0,     3,     3,     2,     0,
       2,     2,     0,     2,     0,     2,     4,     5,     2,     3,
       3,     5,     6,     8,     6,     4,     4,     5,     6,     6,
       5,     3,     3,     4,     5,     5,     5,     5,     5,     4,
       4,     5,     5,     5,     5,     5,     5,     5,     5,     6,
       6,     8,     6,     6,     5,     4,     5,     4,     5,     4,
       5,     4,     5,     5,     5,     5,     6,     5,     5,     6,
       5,     5,     4,     2,     3,     3,     1,     2,     3,     2,
       4,     3,     2,     1,     2,     4,     0,     3,     2,     1,
       2,     3,     3,     3,     3,     2,     3,     0,     5,     0,
       5,     2,     2,     1,     4,     1,     1,     0,     3,     2,
       2,     2,     5,     2,     0,     3,     0,     2,     2,     3,
       2,     2,     3,     2,     2,     2,     1,     3,     2,     2,
       2,     2,     2,     2,     3,     2,     2,     2,     2,     2,
       2,     2,     2,     3,     3,     3,     2,     3,     2,     3,
       3,     4,     2,     2,     2,     3,     3,     3,     2,     3,
       3,     3,     4,     2,     2,     1,     0,     2,     3,     1,
       0,     1,     2,     0,     2,     0,     1,     3,     0,     0,
       2,     0,     3,     0,     3,     0,     3,     3,     1,     0,
       4,     6,     6,     6,     7,     6,     7,     5,     0,     2,
       3,     2,     3,     3,     2,     3,     2,     2,     3,     3,
       5,     4,     4,     2,     3,     3,     4,     4,     4,     5,
       5,     4,     3,     4,     4,     4,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     2,     2,     2,     3,
       3,     4,     0,     3,     0,     3,     0,     3,     2,     3,
       3,     5,     5,     3,     2,     3,     3,     1,     2,     4,
       3,     3,     3,     2,     2,     2,     2,     2,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     1,     2,     2,     2,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 714 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 3596 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 715 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 3602 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 728 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[-1].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[-3].s), SYM_CONSTANT | val->type, val);
   }
#line 3613 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 738 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int((yyvsp[-1].x)); }
#line 3619 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 739 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[0].s)).i; }
#line 3627 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 746 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000000; }
#line 3633 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 747 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000; }
#line 3639 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 748 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1; }
#line 3645 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 756 "cf-parse.y" /* yacc.c:1646  */
    {(yyval.i) = !!(yyvsp[0].i); }
#line 3651 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 757 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 3657 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 758 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 3663 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 759 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 3669 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 760 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 3675 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 761 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 3681 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 768 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[0].s)).px.ip;
   }
#line 3690 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 775 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 3696 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 776 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 3702 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 780 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 3708 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 781 "cf-parse.y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].i) < 1) || ((yyvsp[0].i) > 65535)) cf_error("Invalid port number");
     (yyval.i) = (yyvsp[0].i);
   }
#line 3717 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 788 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!ip_is_prefix((yyvsp[-1].a), (yyvsp[0].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[-1].a); (yyval.px).len = (yyvsp[0].i);
   }
#line 3726 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 796 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.px).addr = (yyvsp[0].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
#line 3732 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 800 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[0].i));
     (yyval.i) = (yyvsp[0].i);
   }
#line 3741 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 804 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.i) = ipa_mklen((yyvsp[0].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[0].a));
   }
#line 3750 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 811 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.time) = tm_parse_datetime((yyvsp[0].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
#line 3760 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 820 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[0].s)).s;
   }
#line 3769 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 827 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 3775 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 828 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 3781 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 834 "cf-parse.y" /* yacc.c:1646  */
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[-2].g);
    c->mask = (yyvsp[-1].i);
    add_tail(&new_config->logfiles, &c->n);
  }
#line 3792 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 843 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 3798 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 844 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = bird_name; }
#line 3804 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 848 "cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[0].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[0].t));
     (yyval.g) = f;
   }
#line 3814 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 853 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[0].t); }
#line 3820 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 854 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = stderr; }
#line 3826 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 858 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 3832 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 859 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 3838 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 863 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << (yyvsp[0].i); }
#line 3844 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 864 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (1 << (yyvsp[0].i)); }
#line 3850 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 868 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_DEBUG[0]; }
#line 3856 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 869 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_TRACE[0]; }
#line 3862 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 870 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_INFO[0]; }
#line 3868 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 871 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_REMOTE[0]; }
#line 3874 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 872 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_WARN[0]; }
#line 3880 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 873 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_ERR[0]; }
#line 3886 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 874 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_AUTH[0]; }
#line 3892 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 875 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_FATAL[0]; }
#line 3898 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 876 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_BUG[0]; }
#line 3904 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 882 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_mrtdump = (yyvsp[-1].i); }
#line 3910 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 883 "cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[-1].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[-1].t));
     new_config->mrtdump_file = fileno(f);
   }
#line 3920 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 892 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_route; }
#line 3926 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 893 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_proto; }
#line 3932 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 894 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_base; }
#line 3938 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 895 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_log; }
#line 3944 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 898 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-1].tf) = (struct timeformat){(yyvsp[0].t), NULL, 0}; }
#line 3950 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 899 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = (struct timeformat){(yyvsp[-2].t), (yyvsp[0].t), (yyvsp[-1].i)}; }
#line 3956 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 900 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
#line 3962 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 901 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%F %T", NULL, 0}; }
#line 3968 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 902 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){NULL, NULL, 0}; }
#line 3974 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 903 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
#line 3980 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 915 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_HARD, (yyvsp[-1].i)); }
#line 3986 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 918 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_SOFT, (yyvsp[-1].i)); }
#line 3992 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 925 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_confirm(); }
#line 3998 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 928 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_undo(); }
#line 4004 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 931 "cf-parse.y" /* yacc.c:1646  */
    { cmd_check_config((yyvsp[-1].t)); }
#line 4010 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 934 "cf-parse.y" /* yacc.c:1646  */
    { cmd_shutdown(); }
#line 4016 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 937 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 4022 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 942 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4028 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 943 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
#line 4034 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 944 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 4040 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 952 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = krt_init_config((yyvsp[-1].i)); }
#line 4046 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 957 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->persist = (yyvsp[0].i); }
#line 4052 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 958 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[0].i);
   }
#line 4061 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 962 "cf-parse.y" /* yacc.c:1646  */
    {
      THIS_KRT->learn = (yyvsp[0].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[0].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   }
#line 4073 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 969 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->devroutes = (yyvsp[0].i); }
#line 4079 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 970 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->graceful_restart = (yyvsp[0].i); }
#line 4085 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 976 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = kif_init_config((yyvsp[-1].i)); }
#line 4091 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 981 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[0].i);
   }
#line 4100 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 985 "cf-parse.y" /* yacc.c:1646  */
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[-1].t);
     kpi->prefix = (yyvsp[0].px).addr;
     kpi->pxlen = (yyvsp[0].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
#line 4112 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 999 "cf-parse.y" /* yacc.c:1646  */
    {
	if ((yyvsp[0].i) <= 0 || (yyvsp[0].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->sys.table_id = (yyvsp[0].i);
   }
#line 4122 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1013 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id = (yyvsp[-1].i32); }
#line 4128 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1014 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id_from = this_ipatt; }
#line 4134 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1018 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (yyvsp[0].i); }
#line 4140 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1020 "cf-parse.y" /* yacc.c:1646  */
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[0].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
#line 4152 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1039 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_addr = (yyvsp[0].a); }
#line 4158 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1040 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_port = (yyvsp[0].i); }
#line 4164 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1041 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 0; }
#line 4170 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1042 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 1; }
#line 4176 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1047 "cf-parse.y" /* yacc.c:1646  */
    { new_config->gr_wait = (yyvsp[-1].i); }
#line 4182 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1053 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4188 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1054 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4194 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 1058 "cf-parse.y" /* yacc.c:1646  */
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[-1].s));
   cf->sorted = (yyvsp[0].i);
   }
#line 4204 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1066 "cf-parse.y" /* yacc.c:1646  */
    {
  this_roa_table = roa_new_table_config((yyvsp[0].s));
}
#line 4212 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1072 "cf-parse.y" /* yacc.c:1646  */
    {
     roa_add_item_config(this_roa_table, (yyvsp[-5].px).addr, (yyvsp[-5].px).len, (yyvsp[-3].i), (yyvsp[-1].i));
   }
#line 4220 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1086 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_PROTO; }
#line 4226 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1087 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_TEMPLATE; }
#line 4232 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1091 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
#line 4243 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1097 "cf-parse.y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[0].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[0].s)->name;
   }
#line 4252 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1101 "cf-parse.y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol((yyvsp[-2].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[-2].s)->name;

     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 4265 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 1113 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[0].i);
   }
#line 4274 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1117 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->disabled = (yyvsp[0].i); }
#line 4280 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 1118 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->debug = (yyvsp[0].i); }
#line 4286 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1119 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->mrtdump = (yyvsp[0].i); }
#line 4292 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1120 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_filter = (yyvsp[0].f); }
#line 4298 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1121 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_filter = (yyvsp[0].f); }
#line 4304 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1122 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->rx_limit = (yyvsp[0].g); }
#line 4310 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1123 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_limit = (yyvsp[0].g); }
#line 4316 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1124 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_limit = (yyvsp[0].g); }
#line 4322 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1125 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_keep_filtered = (yyvsp[0].i); }
#line 4328 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1126 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->table = (yyvsp[0].r); }
#line 4334 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1127 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->router_id = (yyvsp[0].i32); }
#line 4340 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1128 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->dsc = (yyvsp[0].t); }
#line 4346 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1132 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = (yyvsp[0].f); }
#line 4352 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1134 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_ACCEPT; }
#line 4358 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1135 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_REJECT; }
#line 4364 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1139 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 4370 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1140 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_WARN; }
#line 4376 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1141 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_BLOCK; }
#line 4382 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1142 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_RESTART; }
#line 4388 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1143 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 4394 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1147 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[-1].i);
     l->action = (yyvsp[0].i);
     (yyval.g) = l;
   }
#line 4405 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1153 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; }
#line 4411 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1157 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[0].s)->def;
   }
#line 4420 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1165 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_debug = (yyvsp[0].i); }
#line 4426 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1166 "cf-parse.y" /* yacc.c:1646  */
    { new_config->cli_debug = (yyvsp[0].i); }
#line 4432 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1174 "cf-parse.y" /* yacc.c:1646  */
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
#line 4442 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1182 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[0].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
#line 4448 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1183 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 4454 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1184 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[-1].t); this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 4460 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1188 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 1; }
#line 4466 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1189 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 0; }
#line 4472 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1203 "cf-parse.y" /* yacc.c:1646  */
    { iface_patt_check(); }
#line 4478 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1205 "cf-parse.y" /* yacc.c:1646  */
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
#line 4488 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1217 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i) & 0xfc;        if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 255)) cf_error("TX class must be in range 0-255"); }
#line 4494 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ((yyvsp[0].i) & 0x3f) << 2; if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
#line 4500 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1224 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_device, sizeof(struct rt_dev_config), (yyvsp[-1].i));
     init_list(&DIRECT_CFG->iface_list);
   }
#line 4509 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1237 "cf-parse.y" /* yacc.c:1646  */
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
#line 4519 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1251 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4525 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1252 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4531 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1253 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4537 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1258 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 4543 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1262 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_STATES; }
#line 4549 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1263 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_ROUTES; }
#line 4555 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1264 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_FILTERS; }
#line 4561 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1265 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_IFACES; }
#line 4567 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1266 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_EVENTS; }
#line 4573 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1267 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_PACKETS; }
#line 4579 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1273 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4585 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1274 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4591 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1275 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4597 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1280 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 4603 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1284 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_STATES; }
#line 4609 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1285 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_MESSAGES; }
#line 4615 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1306 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[0].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   }
#line 4635 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1324 "cf-parse.y" /* yacc.c:1646  */
    { }
#line 4641 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1325 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->genfrom = (yyvsp[-2].time); }
#line 4647 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1326 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->gento = (yyvsp[-2].time); }
#line 4653 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1327 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accfrom = (yyvsp[-2].time); }
#line 4659 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1328 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accto = (yyvsp[-2].time); }
#line 4665 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1329 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->id = (yyvsp[-2].i); if ((yyvsp[-2].i) <= 0) cf_error("Password ID has to be greated than zero."); }
#line 4671 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1338 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_status(); }
#line 4677 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1341 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_memory(); }
#line 4683 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1344 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 0); }
#line 4689 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1347 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 1); }
#line 4695 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1351 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 4701 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1355 "cf-parse.y" /* yacc.c:1646  */
    { if_show(); }
#line 4707 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1358 "cf-parse.y" /* yacc.c:1646  */
    { if_show_summary(); }
#line 4713 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1362 "cf-parse.y" /* yacc.c:1646  */
    { rt_show((yyvsp[-1].ra)); }
#line 4719 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1365 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
#line 4729 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1370 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
   }
#line 4740 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1376 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
     (yyval.ra)->show_for = 1;
   }
#line 4752 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1383 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[0].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[0].s)->def)->table;
   }
#line 4762 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1388 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 4772 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1393 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 4782 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1398 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->verbose = 1;
   }
#line 4791 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1402 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->primary_only = 1;
   }
#line 4800 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1406 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->filtered = 1;
   }
#line 4809 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1410 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 4823 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1419 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 4836 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1427 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 1;
   }
#line 4845 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1431 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 2;
   }
#line 4854 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1438 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_PREEXPORT; }
#line 4860 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1439 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_EXPORT; }
#line 4866 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1440 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_NOEXPORT; }
#line 4872 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1446 "cf-parse.y" /* yacc.c:1646  */
    { roa_show((yyvsp[-1].ro)); }
#line 4878 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1449 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
#line 4890 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1456 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[0].px).addr;
     (yyval.ro)->pxlen = (yyvsp[0].px).len;
     (yyval.ro)->mode = (yyvsp[-1].i);
   }
#line 4902 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1463 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     (yyval.ro)->asn = (yyvsp[0].i);
   }
#line 4911 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1467 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyvsp[0].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 4921 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1475 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_PX; }
#line 4927 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1476 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_IN; }
#line 4933 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1477 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_FOR; }
#line 4939 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1483 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_symbols((yyvsp[-1].sd)); }
#line 4945 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1486 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
#line 4953 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1489 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TABLE; }
#line 4959 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1490 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FUNCTION; }
#line 4965 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1491 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FILTER; }
#line 4971 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1492 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_PROTO; }
#line 4977 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1493 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TEMPLATE; }
#line 4983 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1494 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_ROA; }
#line 4989 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1495 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->sym = (yyvsp[0].s); }
#line 4995 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1500 "cf-parse.y" /* yacc.c:1646  */
    { 
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
#line 5005 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1505 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5015 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1514 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5024 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1521 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5033 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1528 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[-1].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5042 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1536 "cf-parse.y" /* yacc.c:1646  */
    { rdump(&root_pool); cli_msg(0, ""); }
#line 5048 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1538 "cf-parse.y" /* yacc.c:1646  */
    { sk_dump_all(); cli_msg(0, ""); }
#line 5054 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1540 "cf-parse.y" /* yacc.c:1646  */
    { if_dump_all(); cli_msg(0, ""); }
#line 5060 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1542 "cf-parse.y" /* yacc.c:1646  */
    { neigh_dump_all(); cli_msg(0, ""); }
#line 5066 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1544 "cf-parse.y" /* yacc.c:1646  */
    { rta_dump_all(); cli_msg(0, ""); }
#line 5072 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1546 "cf-parse.y" /* yacc.c:1646  */
    { rt_dump_all(); cli_msg(0, ""); }
#line 5078 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1548 "cf-parse.y" /* yacc.c:1646  */
    { protos_dump_all(); cli_msg(0, ""); }
#line 5084 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1551 "cf-parse.y" /* yacc.c:1646  */
    { cmd_eval((yyvsp[-1].x)); }
#line 5090 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1554 "cf-parse.y" /* yacc.c:1646  */
    {
  cli_set_log_echo(this_cli, (yyvsp[-2].i), (yyvsp[-1].i));
  cli_msg(0, "");
}
#line 5099 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1560 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5105 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1561 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5111 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1562 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5117 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1566 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 4096; }
#line 5123 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1567 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 256 || (yyvsp[0].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[0].i);
   }
#line 5132 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1574 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_disable, 1, 0); }
#line 5138 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1576 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_enable, 1, 0); }
#line 5144 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1578 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_restart, 1, 0); }
#line 5150 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1580 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD); }
#line 5156 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1582 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
#line 5162 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1584 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
#line 5168 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1588 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_debug, 1, (yyvsp[-1].i)); }
#line 5174 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1592 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_mrtdump, 1, (yyvsp[-1].i)); }
#line 5180 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1595 "cf-parse.y" /* yacc.c:1646  */
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
#line 5186 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1598 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5192 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1599 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5198 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1600 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5204 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1604 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5210 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1605 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5216 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1606 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5222 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1614 "cf-parse.y" /* yacc.c:1646  */
    { (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[0].s) ); }
#line 5228 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1615 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-2].s)->def = (yyvsp[0].f);
     (yyvsp[0].f)->name = (yyvsp[-2].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[-2].s)->name );
     cf_pop_scope();
   }
#line 5239 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1624 "cf-parse.y" /* yacc.c:1646  */
    { f_eval_int((yyvsp[0].x)); }
#line 5245 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1628 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_INT; }
#line 5251 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1629 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_BOOL; }
#line 5257 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1630 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_IP; }
#line 5263 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1631 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PREFIX; }
#line 5269 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1632 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PAIR; }
#line 5275 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1633 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_QUAD; }
#line 5281 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1634 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_EC; }
#line 5287 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1635 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_STRING; }
#line 5293 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1636 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH_MASK; }
#line 5299 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1637 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH; }
#line 5305 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1638 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_CLIST; }
#line 5311 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1639 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_ECLIST; }
#line 5317 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1640 "cf-parse.y" /* yacc.c:1646  */
    { 
	switch ((yyvsp[-1].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
#line 5340 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1661 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_VARIABLE | (yyvsp[-1].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[0].s)->name, (yyvsp[-1].i) );
     (yyvsp[0].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[0].s);
   }
#line 5353 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1672 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 5359 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1673 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 5368 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1680 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = (yyvsp[0].s); }
#line 5374 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1681 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 5383 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1688 "cf-parse.y" /* yacc.c:1646  */
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[0].x);
     (yyval.f) = f;
   }
#line 5394 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1697 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[0].s)->def;
   }
#line 5403 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1705 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[0].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
#line 5429 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1729 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[-1].s); }
#line 5435 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1730 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s)=NULL; }
#line 5441 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1734 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-3].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[-3].s);
       (yyval.x)->next = (yyvsp[-1].x);
     } else
       (yyval.x) = (yyvsp[-1].x);
   }
#line 5456 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1747 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Beginning of function %s\n", (yyvsp[0].s)->name );
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[0].s));
   }
#line 5465 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1750 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-3].s)->def = (yyvsp[0].x);
     (yyvsp[-3].s)->aux2 = (yyvsp[-1].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[-3].s)->name); 
     cf_pop_scope();
   }
#line 5476 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1763 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 5482 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1764 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x)->next; (yyvsp[0].x)->next = NULL; }
#line 5488 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1767 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[0].x); }
#line 5494 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1768 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[-1].x)->next ; (yyvsp[-1].x)->next = (yyvsp[0].x); }
#line 5500 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1772 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[0].x);
   }
#line 5508 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1775 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[-1].x);
   }
#line 5516 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1784 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[0].a); }
#line 5522 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1797 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 5528 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1798 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 5534 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1799 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 5540 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1800 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 5546 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1801 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.v) = f_eval((yyvsp[-1].x), cfg_mem);
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
#line 5555 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1805 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!cf_symbol_is_constant((yyvsp[0].s))) cf_error("%s: constant expected", (yyvsp[0].s)->name);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[0].s)))) cf_error("%s: set-incompatible type", (yyvsp[0].s)->name);
     (yyval.v) = *(struct f_val *)((yyvsp[0].s)->def);
   }
#line 5565 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1813 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 5571 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1814 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[-1].x)); }
#line 5577 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1815 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 5583 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1816 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 5589 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1817 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 5595 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1821 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int((yyvsp[0].x)); check_u16((yyval.i)); }
#line 5601 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1824 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = pair((yyvsp[0].i), (yyvsp[0].i)); }
#line 5607 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1825 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = pair((yyvsp[-2].i), (yyvsp[0].i)); }
#line 5613 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1826 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = 0xFFFF; }
#line 5619 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1830 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.e) = f_new_pair_set(pair_a((yyvsp[-3].i32)), pair_b((yyvsp[-3].i32)), pair_a((yyvsp[-1].i32)), pair_b((yyvsp[-1].i32)));
   }
#line 5627 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1833 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Hack: $2 and $4 should be pair_expr, but that would cause shift/reduce conflict */
     if ((pair_a((yyvsp[-9].i32)) != pair_b((yyvsp[-9].i32))) || (pair_a((yyvsp[-7].i32)) != pair_b((yyvsp[-7].i32))))
       cf_error("syntax error");
     (yyval.e) = f_new_pair_item(pair_b((yyvsp[-9].i32)), (yyvsp[-3].i), pair_b((yyvsp[-7].i32)), (yyvsp[-1].i)); 
   }
#line 5638 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1842 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int((yyvsp[0].x)); }
#line 5644 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1845 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RT; }
#line 5650 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1846 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RO; }
#line 5656 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1847 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 5662 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1848 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_GENERIC; }
#line 5668 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1852 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 5674 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1853 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-7].i), 0, (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 5680 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1854 "cf-parse.y" /* yacc.c:1646  */
    {  (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), 0, EC_ALL); }
#line 5686 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1860 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 5692 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1861 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 5698 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1867 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 5704 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1868 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 5710 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1873 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 5716 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1878 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 5722 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1882 "cf-parse.y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[-2].a), (yyvsp[0].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[-2].a), (yyvsp[0].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[-2].a); (yyval.v).val.px.len = (yyvsp[0].i);
   }
#line 5731 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1889 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 5737 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1890 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_PLUS; }
#line 5743 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1891 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_MINUS; }
#line 5749 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1892 "cf-parse.y" /* yacc.c:1646  */
    { 
     if (! ((0 <= (yyvsp[-3].i)) && ((yyvsp[-3].i) <= (yyvsp[-1].i)) && ((yyvsp[-1].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[-3].i), (yyvsp[-1].i));
     (yyval.v) = (yyvsp[-5].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[-3].i) << 16) | ((yyvsp[-1].i) << 8);
   }
#line 5758 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1899 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = f_new_trie(cfg_mem); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 5764 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1900 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = (yyvsp[-2].trie); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 5770 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1903 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = NULL; }
#line 5776 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1904 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[-2].e); t; t = t->left)
       t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-3].e), (yyvsp[-2].e));
   }
#line 5788 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1911 "cf-parse.y" /* yacc.c:1646  */
    { 
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-2].e), t);
 }
#line 5800 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1923 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 5806 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1924 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 5812 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1928 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 5818 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1929 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 5824 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1933 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[-1].i); }
#line 5830 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1934 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
#line 5836 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1935 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; }
#line 5842 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1936 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[-1].x); }
#line 5848 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1937 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 5854 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1941 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[-1].i); }
#line 5860 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1942 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
#line 5866 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1943 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 5872 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1947 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[0].i); }
#line 5878 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1948 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
#line 5884 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1949 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
#line 5890 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1950 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[0].t); }
#line 5896 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1951 "cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 5902 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1952 "cf-parse.y" /* yacc.c:1646  */
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 5908 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1953 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[0].i32); }
#line 5914 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1954 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[-1].e)); DBG( "ook\n" ); }
#line 5920 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1955 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[-1].trie); }
#line 5926 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1956 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[0].i) >> 16; (yyval.x)->a2.i = (yyvsp[0].i) & 0xffff; }
#line 5932 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1957 "cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[0].h); (yyval.x)->a1.p = val; }
#line 5938 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1961 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_dpair((yyvsp[-3].x), (yyvsp[-1].x)); }
#line 5944 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1962 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_ec((yyvsp[-5].i), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 5950 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 1976 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 5975 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 1999 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();

     switch ((yyvsp[0].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x)->code = 'C'; break;
       case SYM_VARIABLE: (yyval.x)->code = 'V'; break;
       default: cf_error("%s: variable expected.", (yyvsp[0].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[0].s)->def;
     (yyval.x)->a2.p = (yyvsp[0].s)->name;
   }
#line 5992 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2013 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_FROM;	(yyval.x)->a1.i = 1; }
#line 5998 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2014 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_GW;	(yyval.x)->a1.i = 1; }
#line 6004 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2015 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = SA_NET; }
#line 6010 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2016 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_PROTO; }
#line 6016 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2017 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = SA_SOURCE; }
#line 6022 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2018 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = SA_SCOPE;	(yyval.x)->a1.i = 1; }
#line 6028 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2019 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = SA_CAST; }
#line 6034 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2020 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = SA_DEST;	(yyval.x)->a1.i = 1; }
#line 6040 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2021 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_IFNAME; }
#line 6046 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2022 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_INT;        (yyval.x)->a2.i = SA_IFINDEX; }
#line 6052 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2026 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6058 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2027 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6064 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2028 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6070 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2029 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6076 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2030 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6082 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2031 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6088 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2032 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6094 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2033 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6100 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2034 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6106 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2035 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6112 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2036 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6118 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2037 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6124 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2038 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6130 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2039 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6136 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2040 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[0].x); }
#line 6142 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2041 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[-1].x); }
#line 6148 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2043 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6154 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2044 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6160 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2045 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6166 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2047 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
#line 6172 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2049 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyval.x)->code = 'a'; }
#line 6178 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2051 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyval.x)->code = P('e','a'); }
#line 6184 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2053 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->aux = T_IP; }
#line 6190 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2054 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6196 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2055 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[-5].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6202 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2056 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6208 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2057 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6214 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2067 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
#line 6220 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
#line 6226 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2069 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
#line 6232 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2070 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6238 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2071 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'a'; }
#line 6244 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2072 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'd'; }
#line 6250 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2073 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'f'; }
#line 6256 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2075 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-1].s), NULL, NULL); }
#line 6262 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2076 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-5].s), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6268 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2081 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 6293 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2104 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_QUITBIRD; }
#line 6299 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2105 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ACCEPT; }
#line 6305 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2106 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_REJECT; }
#line 6311 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2107 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ERROR; }
#line 6317 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2108 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NOP; }
#line 6323 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2109 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NONL; }
#line 6329 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2113 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = NULL; }
#line 6335 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2116 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6341 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2117 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6347 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2118 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-2].x)) {
       (yyvsp[-2].x)->next = (yyvsp[0].x);
       (yyval.x) = (yyvsp[-2].x);
     } else (yyval.x) = (yyvsp[0].x);
   }
#line 6358 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2126 "cf-parse.y" /* yacc.c:1646  */
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[0].x);
     (yyval.x)->next = NULL;
   }
#line 6370 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2133 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[-2].x);
     (yyval.x)->next = (yyvsp[0].x);
   }
#line 6382 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2142 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6388 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2143 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6394 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2147 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[-2].x);
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 6405 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2153 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[-4].x);
     i->a2.p = (yyvsp[-2].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 6420 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2163 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[-3].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[-3].s);
     (yyval.x)->a2.p = (yyvsp[-1].x);
   }
#line 6434 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2172 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6445 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2178 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-3].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6455 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2183 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-3].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6467 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2190 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6477 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2195 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-2].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
#line 6488 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2201 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[-1].x); (yyval.x)->a2.i = (yyvsp[-2].i); }
#line 6494 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2202 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6500 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2203 "cf-parse.y" /* yacc.c:1646  */
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[-3].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[-1].e) );
   }
#line 6511 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2211 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_empty((yyvsp[-3].x)); }
#line 6517 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 2212 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6523 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 2213 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6529 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 2214 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6535 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 2215 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6541 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 2222 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_bfd, sizeof(struct bfd_config), (yyvsp[-1].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
#line 6555 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 2249 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;
}
#line 6569 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2260 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 6575 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 2261 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = (yyvsp[0].i32); }
#line 6581 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 2262 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 6587 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 2263 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->idle_tx_int = (yyvsp[0].i32); }
#line 6593 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 2264 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->multiplier = (yyvsp[0].i); }
#line 6599 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 2265 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->passive = (yyvsp[0].i); }
#line 6605 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 2279 "cf-parse.y" /* yacc.c:1646  */
    { add_tail(&BFD_CFG->patt_list, NODE this_ipatt); }
#line 6611 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 2282 "cf-parse.y" /* yacc.c:1646  */
    { BFD_CFG->multihop = BFD_IFACE; }
#line 6617 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 2286 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 6623 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 2287 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 6629 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 2288 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].t)); }
#line 6635 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 2292 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = IPA_NONE; }
#line 6641 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 2293 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = (yyvsp[0].a); }
#line 6647 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 2297 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 6653 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 2298 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 6659 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 2302 "cf-parse.y" /* yacc.c:1646  */
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[-3].a);
  BFD_NEIGHBOR->local = (yyvsp[-1].a);
  BFD_NEIGHBOR->iface = (yyvsp[-2].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[0].i);

  if ((yyvsp[0].i) && (yyvsp[-2].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[0].i) && ipa_zero((yyvsp[-1].a)))
    cf_error("Multihop neighbor requires specified local address");
}
#line 6679 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 2321 "cf-parse.y" /* yacc.c:1646  */
    { bfd_show_sessions(proto_get_named((yyvsp[-1].s), &proto_bfd)); }
#line 6685 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 2326 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config), (yyvsp[-1].i));
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
 }
#line 6711 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 2352 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->local_as = (yyvsp[-1].i); }
#line 6717 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2353 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-3].a); BGP_CFG->local_as = (yyvsp[-1].i); }
#line 6723 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 2354 "cf-parse.y" /* yacc.c:1646  */
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     if (!ipa_has_link_scope((yyvsp[-5].a)) != !(yyvsp[-4].iface))
       cf_error("Link-local address and interface scope must be used together");

     BGP_CFG->remote_ip = (yyvsp[-5].a);
     BGP_CFG->iface = (yyvsp[-4].iface);
     BGP_CFG->remote_port = ((yyvsp[-3].i) > 0) ? (yyvsp[-3].i) : BGP_PORT;
     BGP_CFG->remote_as = (yyvsp[-1].i);
   }
#line 6739 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2365 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_cluster_id = (yyvsp[-1].i32); }
#line 6745 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2366 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_client = 1; }
#line 6751 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2367 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rs_client = 1; }
#line 6757 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 2368 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->hold_time = (yyvsp[-1].i); }
#line 6763 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2369 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->initial_hold_time = (yyvsp[-1].i); }
#line 6769 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 2370 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_retry_time = (yyvsp[-1].i); }
#line 6775 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 2371 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->keepalive_time = (yyvsp[-1].i); }
#line 6781 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2372 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 0; }
#line 6787 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2373 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 64; }
#line 6793 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2374 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>255)) cf_error("Multihop must be in range 1-255"); }
#line 6799 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2375 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
#line 6805 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2376 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
#line 6811 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 2377 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_SELF; }
#line 6817 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 507:
#line 2378 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_DROP; }
#line 6823 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 508:
#line 2379 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
#line 6829 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 509:
#line 2380 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_DIRECT; }
#line 6835 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 510:
#line 2381 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
#line 6841 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2382 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->compare_path_lengths = (yyvsp[-1].i); }
#line 6847 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2383 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->med_metric = (yyvsp[-1].i); }
#line 6853 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2384 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_metric = (yyvsp[-1].i); }
#line 6859 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2385 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->prefer_older = (yyvsp[-1].i); }
#line 6865 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2386 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->deterministic_med = (yyvsp[-1].i); }
#line 6871 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2387 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_med = (yyvsp[-1].i); }
#line 6877 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2388 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_local_pref = (yyvsp[-1].i); }
#line 6883 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2389 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-1].a); }
#line 6889 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2390 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->start_delay_time = (yyvsp[-1].i); }
#line 6895 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2391 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_amnesia_time = (yyvsp[-1].i); }
#line 6901 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2392 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_delay_time_min = (yyvsp[-3].i); BGP_CFG->error_delay_time_max = (yyvsp[-1].i); }
#line 6907 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2393 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->disable_after_error = (yyvsp[-1].i); }
#line 6913 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2394 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_refresh = (yyvsp[-1].i); }
#line 6919 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2395 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_as4 = (yyvsp[-1].i); }
#line 6925 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 2396 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->capabilities = (yyvsp[-1].i); }
#line 6931 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2397 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->advertise_ipv4 = (yyvsp[-1].i); }
#line 6937 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 2398 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->password = (yyvsp[-1].t); }
#line 6943 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 2399 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[-1].i);
     this_proto->in_limit->action = PLA_RESTART;
   }
#line 6953 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 2404 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->passive = (yyvsp[-1].i); }
#line 6959 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 530:
#line 2405 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->interpret_communities = (yyvsp[-1].i); }
#line 6965 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 531:
#line 2406 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->secondary = (yyvsp[-1].i); }
#line 6971 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 2407 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_RX; }
#line 6977 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 2408 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_TX; }
#line 6983 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 2409 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = (yyvsp[-1].i) ? ADD_PATH_FULL : 0; }
#line 6989 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 2410 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = -1; }
#line 6995 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 2411 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = (yyvsp[-1].i); }
#line 7001 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2412 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = (yyvsp[-1].i); }
#line 7007 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2413 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
#line 7013 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 539:
#line 2414 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_time = (yyvsp[-1].i); }
#line 7019 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 2415 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_table = (yyvsp[-1].r); }
#line 7025 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 2416 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->ttl_security = (yyvsp[-1].i); }
#line 7031 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 2417 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 7037 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 2428 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config), (yyvsp[-1].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  }
#line 7049 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 2444 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->rfc1583 = (yyvsp[0].i); }
#line 7055 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 2445 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->stub_router = (yyvsp[0].i); }
#line 7061 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 2446 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[0].i) ? DEFAULT_ECMP_LIMIT : 0; }
#line 7067 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 2447 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 7073 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 551:
#line 2448 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->merge_external = (yyvsp[0].i); }
#line 7079 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 2449 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->tick = (yyvsp[0].i); if((yyvsp[0].i)<=0) cf_error("Tick must be greater than zero"); }
#line 7085 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 2453 "cf-parse.y" /* yacc.c:1646  */
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[0].i32);
  this_area->default_cost = DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
#line 7103 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 555:
#line 2468 "cf-parse.y" /* yacc.c:1646  */
    { ospf_area_finish(); }
#line 7109 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 2477 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = (yyvsp[0].i) ? 0 : OPT_E; /* We should remove the option */ }
#line 7115 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 2478 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = OPT_N; }
#line 7121 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 2479 "cf-parse.y" /* yacc.c:1646  */
    { this_area->summary = (yyvsp[0].i); }
#line 7127 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 2480 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_nssa = (yyvsp[0].i); }
#line 7133 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 562:
#line 2481 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); check_defcost((yyvsp[0].i)); }
#line 7139 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 563:
#line 2482 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i) | LSA_EXT_EBIT; check_defcost((yyvsp[0].i)); }
#line 7145 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 2483 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i);  check_defcost((yyvsp[0].i)); }
#line 7151 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 565:
#line 2484 "cf-parse.y" /* yacc.c:1646  */
    { this_area->translator = (yyvsp[0].i); }
#line 7157 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 566:
#line 2485 "cf-parse.y" /* yacc.c:1646  */
    { this_area->transint = (yyvsp[0].i); }
#line 7163 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 567:
#line 2486 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->net_list; }
#line 7169 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 569:
#line 2487 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->enet_list; }
#line 7175 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 2499 "cf-parse.y" /* yacc.c:1646  */
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[0].px);
     this_stubnet->cost = COST_D;
   }
#line 7186 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 2513 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->hidden = (yyvsp[0].i); }
#line 7192 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 580:
#line 2514 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->summary = (yyvsp[0].i); }
#line 7198 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 581:
#line 2515 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->cost = (yyvsp[0].i); }
#line 7204 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 2519 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7210 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 2520 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7216 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 2529 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 7222 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 2530 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Retransmit int must be greater than zero"); }
#line 7228 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 2531 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 7234 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 2532 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; }
#line 7240 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 2533 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 7246 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 2534 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 7252 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 2535 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
#line 7258 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 2536 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
#line 7264 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 2537 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
#line 7270 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 597:
#line 2542 "cf-parse.y" /* yacc.c:1646  */
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[0].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 }
#line 7293 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 598:
#line 2563 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->cost = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Cost must be in range 1-65535"); }
#line 7299 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 2564 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 7305 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2565 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->pollint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Poll int must be greater than zero"); }
#line 7311 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 2566 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Retransmit int must be greater than zero"); }
#line 7317 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 2567 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; }
#line 7323 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2568 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 7329 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 2569 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 7335 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 2570 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 7341 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 2571 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 7347 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 2572 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 7353 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 2573 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 7359 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 2574 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 7365 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 2575 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 7371 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 2576 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 7377 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 2577 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 7383 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 2578 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->real_bcast = (yyvsp[0].i); if (OSPF_VERSION != 2) cf_error("Real broadcast option requires OSPFv2"); }
#line 7389 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 2579 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ptp_netmask = (yyvsp[0].i); if (OSPF_VERSION != 2) cf_error("Real netmask option requires OSPFv2"); }
#line 7395 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 2580 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 7401 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 2581 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->priority = (yyvsp[0].i) ; if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Priority must be in range 0-255"); }
#line 7407 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 2582 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->strictnbma = (yyvsp[0].i) ; }
#line 7413 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 2583 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->stub = (yyvsp[0].i) ; }
#line 7419 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 2584 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->check_link = (yyvsp[0].i); }
#line 7425 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 2585 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 7431 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 2587 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
#line 7437 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 2588 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
#line 7443 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 2589 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
#line 7449 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 625:
#line 2590 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = 0; }
#line 7455 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 626:
#line 2591 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
#line 7461 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 2592 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
#line 7467 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 2593 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_tos = (yyvsp[0].i); }
#line 7473 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 2594 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_priority = (yyvsp[0].i); }
#line 7479 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 2595 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_length = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
#line 7485 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 2596 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = (yyvsp[0].i); }
#line 7491 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 632:
#line 2597 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = 2; }
#line 7497 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 633:
#line 2598 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 7503 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 634:
#line 2599 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bsd_secondary = (yyvsp[0].i); }
#line 7509 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 639:
#line 2611 "cf-parse.y" /* yacc.c:1646  */
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[0].px).addr;
   this_pref->px.len = (yyvsp[0].px).len;
 }
#line 7520 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 641:
#line 2621 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->hidden = 1; }
#line 7526 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 2622 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->tag = (yyvsp[0].i); }
#line 7532 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 2631 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 7538 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 646:
#line 2632 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 7544 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 647:
#line 2636 "cf-parse.y" /* yacc.c:1646  */
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[-2].a);
   this_nbma->eligible=(yyvsp[-1].i);
 }
#line 7555 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 648:
#line 2645 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
#line 7581 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 650:
#line 2670 "cf-parse.y" /* yacc.c:1646  */
    { set_instance_id((yyvsp[0].i)); }
#line 7587 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 651:
#line 2674 "cf-parse.y" /* yacc.c:1646  */
    { if (OSPF_VERSION == 3) iface_patt_check(); }
#line 7593 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 657:
#line 2688 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7599 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 659:
#line 2693 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 7605 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 660:
#line 2699 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh(proto_get_named((yyvsp[-1].s), &proto_ospf)); }
#line 7611 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 661:
#line 2702 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_neigh(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 7617 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 662:
#line 2705 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_iface(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 7623 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 663:
#line 2710 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 1); }
#line 7629 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 664:
#line 2713 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 0); }
#line 7635 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 665:
#line 2718 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 1); }
#line 7641 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 666:
#line 2721 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 0); }
#line 7647 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 667:
#line 2725 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_lsadb((yyvsp[-1].ld)); }
#line 7653 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 668:
#line 2728 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
#line 7661 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 669:
#line 2731 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
#line 7667 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 670:
#line 2732 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[0].i32); }
#line 7673 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 671:
#line 2733 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
#line 7679 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 672:
#line 2734 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->type = (yyvsp[0].i); }
#line 7685 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 673:
#line 2735 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->lsid = (yyvsp[0].i32); }
#line 7691 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 674:
#line 2736 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
#line 7697 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 675:
#line 2737 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->router = (yyvsp[0].i32); }
#line 7703 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 676:
#line 2738 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->name = (yyvsp[0].s); }
#line 7709 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 677:
#line 2744 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config), (yyvsp[-1].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
#line 7718 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 680:
#line 2753 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-1].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[-1].s)->def;
   }
#line 7728 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 681:
#line 2758 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_OPAQUE; }
#line 7734 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 2759 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
#line 7740 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 2765 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config), (yyvsp[-1].i));
     rip_init_config(RIP_CFG);
   }
#line 7749 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 2774 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->infinity = (yyvsp[-1].i); }
#line 7755 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 687:
#line 2775 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->port = (yyvsp[-1].i); }
#line 7761 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 688:
#line 2776 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->period = (yyvsp[-1].i); }
#line 7767 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 689:
#line 2777 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->garbage_time = (yyvsp[-1].i); }
#line 7773 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 2778 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->timeout_time = (yyvsp[-1].i); }
#line 7779 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 691:
#line 2779 "cf-parse.y" /* yacc.c:1646  */
    {RIP_CFG->authtype = (yyvsp[-1].i); }
#line 7785 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 2781 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->honor = HO_ALWAYS; }
#line 7791 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 2782 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->honor = HO_NEIGHBOR; }
#line 7797 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 2783 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->honor = HO_NEVER; }
#line 7803 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 697:
#line 2788 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=AT_PLAINTEXT; }
#line 7809 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 698:
#line 2789 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=AT_MD5; }
#line 7815 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 699:
#line 2790 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=AT_NONE; }
#line 7821 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 2795 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_BROADCAST; }
#line 7827 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 2796 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=0; }
#line 7833 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 702:
#line 2797 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_QUIET; }
#line 7839 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 2798 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_NOLISTEN; }
#line 7845 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 704:
#line 2799 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; }
#line 7851 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 2803 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->metric = (yyvsp[0].i); }
#line 7857 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 707:
#line 2804 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->mode |= (yyvsp[0].i); }
#line 7863 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 708:
#line 2805 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->tx_tos = (yyvsp[0].i); }
#line 7869 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 709:
#line 2806 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->tx_priority = (yyvsp[0].i); }
#line 7875 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 2807 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->ttl_security = (yyvsp[0].i); }
#line 7881 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 2808 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->ttl_security = 2; }
#line 7887 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 2822 "cf-parse.y" /* yacc.c:1646  */
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
     RIP_IPATT->tx_tos = IP_PREC_INTERNET_CONTROL;
     RIP_IPATT->tx_priority = sk_priority_control;
     RIP_IPATT->ttl_security = RIP_DEFAULT_TTL_SECURITY;
   }
#line 7901 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 718:
#line 2841 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config), (yyvsp[-1].i));
     static_init_config((struct static_config *) this_proto);
  }
#line 7910 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 721:
#line 2850 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->check_link = (yyvsp[-1].i); }
#line 7916 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 722:
#line 2851 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->igp_table = (yyvsp[-1].r); }
#line 7922 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 724:
#line 2855 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[0].px).addr;
     this_srt->masklen = (yyvsp[0].px).len;
  }
#line 7933 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 725:
#line 2864 "cf-parse.y" /* yacc.c:1646  */
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[-1].a);
     this_srt_nh->via_if = (yyvsp[0].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
   }
#line 7946 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 726:
#line 2872 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt_nh->masklen = (yyvsp[0].i) - 1; /* really */
     if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
#line 7955 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 727:
#line 2879 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->mp_next = this_srt_nh; }
#line 7961 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 728:
#line 2880 "cf-parse.y" /* yacc.c:1646  */
    { last_srt_nh->mp_next = this_srt_nh; }
#line 7967 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 729:
#line 2884 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[-1].a);
      this_srt->via_if = (yyvsp[0].iface);
   }
#line 7977 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 730:
#line 2889 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[0].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
#line 7988 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 731:
#line 2895 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_MULTIPATH;
   }
#line 7996 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 732:
#line 2898 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[0].a);
   }
#line 8005 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 733:
#line 2903 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 8011 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 734:
#line 2904 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 8017 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 735:
#line 2905 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 8023 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 736:
#line 2906 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 8029 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 737:
#line 2907 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_PROHIBIT; }
#line 8035 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 738:
#line 2911 "cf-parse.y" /* yacc.c:1646  */
    { static_show(proto_get_named((yyvsp[-1].s), &proto_static)); }
#line 8041 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 804:
#line 2919 "cf-parse.y" /* yacc.c:1646  */
    { bgp_check_config(BGP_CFG); }
#line 8047 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 805:
#line 2919 "cf-parse.y" /* yacc.c:1646  */
    { ospf_proto_finish(); }
#line 8053 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 807:
#line 2919 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->passwords = get_passwords(); }
#line 8059 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 816:
#line 2922 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
#line 8065 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 817:
#line 2922 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
#line 8071 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 818:
#line 2922 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
#line 8077 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 819:
#line 2922 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
#line 8083 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 820:
#line 2923 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
#line 8089 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 821:
#line 2923 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 8095 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 822:
#line 2924 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
#line 8101 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 823:
#line 2925 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
#line 8107 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 824:
#line 2926 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
#line 8113 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 825:
#line 2927 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
#line 8119 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 826:
#line 2928 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
#line 8125 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 827:
#line 2929 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
#line 8131 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 828:
#line 2930 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
#line 8137 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 829:
#line 2931 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
#line 8143 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 830:
#line 2932 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
#line 8149 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 831:
#line 2933 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
#line 8155 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 832:
#line 2934 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
#line 8161 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 833:
#line 2934 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
#line 8167 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 834:
#line 2934 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
#line 8173 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 835:
#line 2934 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
#line 8179 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 836:
#line 2934 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
#line 8185 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 837:
#line 2934 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
#line 8191 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 838:
#line 2934 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
#line 8197 "cf-parse.tab.c" /* yacc.c:1646  */
    break;


#line 8201 "cf-parse.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2936 "cf-parse.y" /* yacc.c:1906  */

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

